SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Repository'!
SystemOrganization addCategory: #'SqSync-Tools'!
SystemOrganization addCategory: #'SqSync-AddressBook'!
SystemOrganization addCategory: #'SqSync-AddressBook-Test'!
SystemOrganization addCategory: #'SqSync-Tests'!
SystemOrganization addCategory: #'SqSync-ProjectAnalyzation'!
SystemOrganization addCategory: #SqSync!

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/31/2010 08:37:35.378'!
detect: aBlock ifNone: aNoneBlock

	^ self mutex critical: [super detect: aBlock ifNone: aNoneBlock]! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/30/2010 19:50:56.398'!
size

	^ self mutex critical: [super size]! !

UserInterface subclass: #SyAddressBook2Ui
	instanceVariableNames: 'morph1 morph2 personsLabel morph3 personList morph4 silentButton spacer addPersonButton morph5 morph6 morph7 givenNameEdit surnameEdit morph8 birthdayLabel morph9 birthdayEdit addressBox addressLabel morphy2 streetEdit streetNumberEdit morphy3 postalEdit townEdit morph10 morph11 friendsLabel morph13 friendsList morph14 friendCombo addFriendButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook'!

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:17.09'!
addFriendButton
	"No description given."
	
	^ addFriendButton! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.139'!
addPersonButton
	"No description given."
	
	^ addPersonButton! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.514'!
addressBox
	"No description given."
	
	^ addressBox! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.549'!
addressLabel
	"No description given."
	
	^ addressLabel! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.473'!
birthdayEdit
	"No description given."
	
	^ birthdayEdit! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.399'!
birthdayLabel
	"No description given."
	
	^ birthdayLabel! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:17.055'!
friendCombo
	"No description given."
	
	^ friendCombo! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.897'!
friendsLabel
	"No description given."
	
	^ friendsLabel! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.98'!
friendsList
	"No description given."
	
	^ friendsList! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.289'!
givenNameEdit
	"No description given."
	
	^ givenNameEdit! !

!SyAddressBook2Ui methodsFor: 'ui - private' stamp: 'mt 7/21/2010 20:46:17.185'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: 636@654.
	panel position: 447@122.
	panel hResizing: #spaceFill.
	panel vResizing: #spaceFill.
	panel cellInset: 4.
	panel cellPositioning: #center.
	panel cellSpacing: #none.
	panel layoutInset: 4.
	panel listCentering: #topLeft.
	panel listDirection: #leftToRight.
	panel listSpacing: #none.
	panel maxCellSize: 1073741823.
	panel minCellSize: 0.
	panel wrapCentering: #topLeft.
	panel wrapDirection: #none.
	panel setProperty: #objectName toValue: 'panel'.
	panel setProperty: #objectDescription toValue: ''.
	morph1 := UiContainer new.
	morph1 changeTableLayout.
	morph1 extent: 368@646.
	morph1 position: 451@126.
	morph1 hResizing: #spaceFill.
	morph1 vResizing: #spaceFill.
	morph1 cellInset: 4.
	morph1 cellPositioning: #center.
	morph1 cellSpacing: #none.
	morph1 layoutInset: 0.
	morph1 listCentering: #topLeft.
	morph1 listDirection: #topToBottom.
	morph1 listSpacing: #none.
	morph1 maxCellSize: 1073741823.
	morph1 minCellSize: 0.
	morph1 wrapCentering: #topLeft.
	morph1 wrapDirection: #none.
	morph1 setProperty: #objectName toValue: 'morph1'.
	morph1 setProperty: #objectDescription toValue: 'No description given.'.
	morph2 := UiContainer new.
	morph2 changeTableLayout.
	morph2 extent: 368@26.
	morph2 position: 451@126.
	morph2 hResizing: #spaceFill.
	morph2 vResizing: #shrinkWrap.
	morph2 cellInset: 4.
	morph2 cellPositioning: #center.
	morph2 cellSpacing: #none.
	morph2 layoutInset: 4.
	morph2 listCentering: #topLeft.
	morph2 listDirection: #leftToRight.
	morph2 listSpacing: #none.
	morph2 maxCellSize: 1073741823.
	morph2 minCellSize: 0.
	morph2 wrapCentering: #topLeft.
	morph2 wrapDirection: #none.
	morph2 setProperty: #objectName toValue: 'morph2'.
	morph2 setProperty: #objectDescription toValue: 'No description given.'.
	personsLabel := UiLabel new.
	personsLabel changeTableLayout.
	personsLabel extent: 10@18.
	personsLabel position: 455@130.
	personsLabel hResizing: #shrinkWrap.
	personsLabel vResizing: #shrinkWrap.
	personsLabel cellInset: 0.
	personsLabel cellPositioning: #center.
	personsLabel cellSpacing: #none.
	personsLabel layoutInset: 0.
	personsLabel listCentering: #topLeft.
	personsLabel listDirection: #leftToRight.
	personsLabel listSpacing: #none.
	personsLabel maxCellSize: 1073741823.
	personsLabel minCellSize: 0.
	personsLabel wrapCentering: #topLeft.
	personsLabel wrapDirection: #none.
	personsLabel text: 'O'.
	personsLabel setProperty: #objectName toValue: 'personsLabel'.
	personsLabel setProperty: #objectDescription toValue: 'No description given.'.
	morph2 addMorphBack: personsLabel.
	morph3 := UiLabel new.
	morph3 changeTableLayout.
	morph3 extent: 49@18.
	morph3 position: 469@130.
	morph3 hResizing: #shrinkWrap.
	morph3 vResizing: #shrinkWrap.
	morph3 cellInset: 0.
	morph3 cellPositioning: #center.
	morph3 cellSpacing: #none.
	morph3 layoutInset: 0.
	morph3 listCentering: #topLeft.
	morph3 listDirection: #leftToRight.
	morph3 listSpacing: #none.
	morph3 maxCellSize: 1073741823.
	morph3 minCellSize: 0.
	morph3 wrapCentering: #topLeft.
	morph3 wrapDirection: #none.
	morph3 text: 'Persons'.
	morph3 setProperty: #objectName toValue: 'morph3'.
	morph3 setProperty: #objectDescription toValue: 'No description given.'.
	morph2 addMorphBack: morph3.
	morph1 addMorphBack: morph2.
	personList := UiListWidget new.
	personList extent: 368@582.
	personList position: 451@156.
	personList hResizing: #spaceFill.
	personList vResizing: #spaceFill.
	personList cellInset: 0.
	personList cellPositioning: #center.
	personList cellSpacing: #none.
	personList layoutInset: 0.
	personList listCentering: #topLeft.
	personList listDirection: #topToBottom.
	personList listSpacing: #none.
	personList maxCellSize: 1073741823.
	personList minCellSize: 0.
	personList wrapCentering: #topLeft.
	personList wrapDirection: #none.
	personList setProperty: #objectName toValue: 'personList'.
	personList setProperty: #objectDescription toValue: 'No description given.'.
	morph1 addMorphBack: personList.
	morph4 := UiContainer new.
	morph4 changeTableLayout.
	morph4 extent: 368@29.
	morph4 position: 451@743.
	morph4 hResizing: #spaceFill.
	morph4 vResizing: #shrinkWrap.
	morph4 cellInset: 4.
	morph4 cellPositioning: #center.
	morph4 cellSpacing: #none.
	morph4 layoutInset: 0.
	morph4 listCentering: #topLeft.
	morph4 listDirection: #leftToRight.
	morph4 listSpacing: #none.
	morph4 maxCellSize: 1073741823.
	morph4 minCellSize: 0.
	morph4 wrapCentering: #topLeft.
	morph4 wrapDirection: #none.
	morph4 setProperty: #objectName toValue: 'morph4'.
	morph4 setProperty: #objectDescription toValue: 'No description given.'.
	silentButton := UiCheckBox new.
	silentButton changeTableLayout.
	silentButton extent: 118@28.
	silentButton position: 451@744.
	silentButton hResizing: #shrinkWrap.
	silentButton vResizing: #shrinkWrap.
	silentButton cellInset: 4.
	silentButton cellPositioning: #center.
	silentButton cellSpacing: #none.
	silentButton layoutInset: 4.
	silentButton listCentering: #topLeft.
	silentButton listDirection: #leftToRight.
	silentButton listSpacing: #none.
	silentButton maxCellSize: 1073741823.
	silentButton minCellSize: 0.
	silentButton wrapCentering: #topLeft.
	silentButton wrapDirection: #none.
	silentButton text: 'Silent Mode'.
	silentButton setProperty: #objectName toValue: 'silentButton'.
	silentButton setProperty: #objectDescription toValue: 'No description given.'.
	morph4 addMorphBack: silentButton.
	spacer := UiContainer new.
	spacer extent: 140@10.
	spacer position: 573@753.
	spacer hResizing: #spaceFill.
	spacer vResizing: #rigid.
	spacer cellInset: 4.
	spacer cellPositioning: #center.
	spacer cellSpacing: #none.
	spacer layoutInset: 4.
	spacer listCentering: #topLeft.
	spacer listDirection: #topToBottom.
	spacer listSpacing: #none.
	spacer maxCellSize: 1073741823.
	spacer minCellSize: 0.
	spacer wrapCentering: #topLeft.
	spacer wrapDirection: #none.
	spacer setProperty: #objectName toValue: 'spacer'.
	spacer setProperty: #objectDescription toValue: 'No description given.'.
	morph4 addMorphBack: spacer.
	addPersonButton := UiPushButton new.
	addPersonButton changeTableLayout.
	addPersonButton extent: 100@28.
	addPersonButton position: 717@743.
	addPersonButton hResizing: #shrinkWrap.
	addPersonButton vResizing: #shrinkWrap.
	addPersonButton cellInset: 4.
	addPersonButton cellPositioning: #center.
	addPersonButton cellSpacing: #none.
	addPersonButton layoutInset: 4.
	addPersonButton listCentering: #topLeft.
	addPersonButton listDirection: #leftToRight.
	addPersonButton listSpacing: #none.
	addPersonButton maxCellSize: 1073741823.
	addPersonButton minCellSize: 0.
	addPersonButton wrapCentering: #topLeft.
	addPersonButton wrapDirection: #none.
	addPersonButton text: 'Add Person'.
	addPersonButton setProperty: #objectName toValue: 'addPersonButton'.
	addPersonButton setProperty: #objectDescription toValue: 'No description given.'.
	morph4 addMorphBack: addPersonButton.
	morph1 addMorphBack: morph4.
	panel addMorphBack: morph1.
	morph5 := UiContainer new.
	morph5 changeTableLayout.
	morph5 extent: 250@646.
	morph5 position: 826@126.
	morph5 hResizing: #rigid.
	morph5 vResizing: #spaceFill.
	morph5 cellInset: 4.
	morph5 cellPositioning: #center.
	morph5 cellSpacing: #none.
	morph5 layoutInset: 0.
	morph5 listCentering: #topLeft.
	morph5 listDirection: #topToBottom.
	morph5 listSpacing: #none.
	morph5 maxCellSize: 1073741823.
	morph5 minCellSize: 0.
	morph5 wrapCentering: #topLeft.
	morph5 wrapDirection: #none.
	morph5 setProperty: #objectName toValue: 'morph5'.
	morph5 setProperty: #objectDescription toValue: 'No description given.'.
	morph6 := UiContainer new.
	morph6 changeTableLayout.
	morph6 extent: 250@30.
	morph6 position: 826@126.
	morph6 hResizing: #spaceFill.
	morph6 vResizing: #shrinkWrap.
	morph6 cellInset: 4.
	morph6 cellPositioning: #center.
	morph6 cellSpacing: #none.
	morph6 layoutInset: 4.
	morph6 listCentering: #topLeft.
	morph6 listDirection: #leftToRight.
	morph6 listSpacing: #none.
	morph6 maxCellSize: 1073741823.
	morph6 minCellSize: 0.
	morph6 wrapCentering: #topLeft.
	morph6 wrapDirection: #none.
	morph6 setProperty: #objectName toValue: 'morph6'.
	morph6 setProperty: #objectDescription toValue: 'No description given.'.
	morph7 := UiLabel new.
	morph7 changeTableLayout.
	morph7 extent: 34@18.
	morph7 position: 830@132.
	morph7 hResizing: #shrinkWrap.
	morph7 vResizing: #shrinkWrap.
	morph7 cellInset: 0.
	morph7 cellPositioning: #center.
	morph7 cellSpacing: #none.
	morph7 layoutInset: 0.
	morph7 listCentering: #topLeft.
	morph7 listDirection: #leftToRight.
	morph7 listSpacing: #none.
	morph7 maxCellSize: 1073741823.
	morph7 minCellSize: 0.
	morph7 wrapCentering: #topLeft.
	morph7 wrapDirection: #none.
	morph7 text: 'Name'.
	morph7 setProperty: #objectName toValue: 'morph7'.
	morph7 setProperty: #objectDescription toValue: 'No description given.'.
	morph6 addMorphBack: morph7.
	givenNameEdit := UiLineEdit new.
	givenNameEdit extent: 100@20.
	givenNameEdit position: 868@131.
	givenNameEdit hResizing: #spaceFill.
	givenNameEdit vResizing: #rigid.
	givenNameEdit cellInset: 0.
	givenNameEdit cellPositioning: #center.
	givenNameEdit cellSpacing: #none.
	givenNameEdit layoutInset: 0.
	givenNameEdit listCentering: #topLeft.
	givenNameEdit listDirection: #topToBottom.
	givenNameEdit listSpacing: #none.
	givenNameEdit maxCellSize: 1073741823.
	givenNameEdit minCellSize: 0.
	givenNameEdit wrapCentering: #topLeft.
	givenNameEdit wrapDirection: #none.
	givenNameEdit setProperty: #objectName toValue: 'givenNameEdit'.
	givenNameEdit setProperty: #objectDescription toValue: 'No description given.'.
	morph6 addMorphBack: givenNameEdit.
	surnameEdit := UiLineEdit new.
	surnameEdit extent: 100@20.
	surnameEdit position: 972@131.
	surnameEdit hResizing: #spaceFill.
	surnameEdit vResizing: #rigid.
	surnameEdit cellInset: 0.
	surnameEdit cellPositioning: #center.
	surnameEdit cellSpacing: #none.
	surnameEdit layoutInset: 0.
	surnameEdit listCentering: #topLeft.
	surnameEdit listDirection: #topToBottom.
	surnameEdit listSpacing: #none.
	surnameEdit maxCellSize: 1073741823.
	surnameEdit minCellSize: 0.
	surnameEdit wrapCentering: #topLeft.
	surnameEdit wrapDirection: #none.
	surnameEdit setProperty: #objectName toValue: 'surnameEdit'.
	surnameEdit setProperty: #objectDescription toValue: 'No description given.'.
	morph6 addMorphBack: surnameEdit.
	morph5 addMorphBack: morph6.
	morph8 := UiContainer new.
	morph8 changeTableLayout.
	morph8 extent: 250@30.
	morph8 position: 826@160.
	morph8 hResizing: #spaceFill.
	morph8 vResizing: #shrinkWrap.
	morph8 cellInset: 4.
	morph8 cellPositioning: #center.
	morph8 cellSpacing: #none.
	morph8 layoutInset: 4.
	morph8 listCentering: #topLeft.
	morph8 listDirection: #leftToRight.
	morph8 listSpacing: #none.
	morph8 maxCellSize: 1073741823.
	morph8 minCellSize: 0.
	morph8 wrapCentering: #topLeft.
	morph8 wrapDirection: #none.
	morph8 setProperty: #objectName toValue: 'morph8'.
	morph8 setProperty: #objectDescription toValue: 'No description given.'.
	birthdayLabel := UiLabel new.
	birthdayLabel changeTableLayout.
	birthdayLabel extent: 10@18.
	birthdayLabel position: 830@166.
	birthdayLabel hResizing: #shrinkWrap.
	birthdayLabel vResizing: #shrinkWrap.
	birthdayLabel cellInset: 0.
	birthdayLabel cellPositioning: #center.
	birthdayLabel cellSpacing: #none.
	birthdayLabel layoutInset: 0.
	birthdayLabel listCentering: #topLeft.
	birthdayLabel listDirection: #leftToRight.
	birthdayLabel listSpacing: #none.
	birthdayLabel maxCellSize: 1073741823.
	birthdayLabel minCellSize: 0.
	birthdayLabel wrapCentering: #topLeft.
	birthdayLabel wrapDirection: #none.
	birthdayLabel text: 'O'.
	birthdayLabel setProperty: #objectName toValue: 'birthdayLabel'.
	birthdayLabel setProperty: #objectDescription toValue: 'No description given.'.
	morph8 addMorphBack: birthdayLabel.
	morph9 := UiLabel new.
	morph9 changeTableLayout.
	morph9 extent: 50@18.
	morph9 position: 844@166.
	morph9 hResizing: #shrinkWrap.
	morph9 vResizing: #shrinkWrap.
	morph9 cellInset: 0.
	morph9 cellPositioning: #center.
	morph9 cellSpacing: #none.
	morph9 layoutInset: 0.
	morph9 listCentering: #topLeft.
	morph9 listDirection: #leftToRight.
	morph9 listSpacing: #none.
	morph9 maxCellSize: 1073741823.
	morph9 minCellSize: 0.
	morph9 wrapCentering: #topLeft.
	morph9 wrapDirection: #none.
	morph9 text: 'Birthday'.
	morph9 setProperty: #objectName toValue: 'morph9'.
	morph9 setProperty: #objectDescription toValue: 'No description given.'.
	morph8 addMorphBack: morph9.
	birthdayEdit := UiLineEdit new.
	birthdayEdit extent: 174@20.
	birthdayEdit position: 898@165.
	birthdayEdit hResizing: #spaceFill.
	birthdayEdit vResizing: #rigid.
	birthdayEdit cellInset: 0.
	birthdayEdit cellPositioning: #center.
	birthdayEdit cellSpacing: #none.
	birthdayEdit layoutInset: 0.
	birthdayEdit listCentering: #topLeft.
	birthdayEdit listDirection: #topToBottom.
	birthdayEdit listSpacing: #none.
	birthdayEdit maxCellSize: 1073741823.
	birthdayEdit minCellSize: 0.
	birthdayEdit wrapCentering: #topLeft.
	birthdayEdit wrapDirection: #none.
	birthdayEdit setProperty: #objectName toValue: 'birthdayEdit'.
	birthdayEdit setProperty: #objectDescription toValue: 'No description given.'.
	morph8 addMorphBack: birthdayEdit.
	morph5 addMorphBack: morph8.
	addressBox := UiContainer new.
	addressBox changeTableLayout.
	addressBox extent: 250@89.
	addressBox position: 826@193.
	addressBox hResizing: #spaceFill.
	addressBox vResizing: #shrinkWrap.
	addressBox cellInset: 4.
	addressBox cellPositioning: #center.
	addressBox cellSpacing: #none.
	addressBox layoutInset: 0.
	addressBox listCentering: #topLeft.
	addressBox listDirection: #topToBottom.
	addressBox listSpacing: #none.
	addressBox maxCellSize: 1073741823.
	addressBox minCellSize: 0.
	addressBox wrapCentering: #topLeft.
	addressBox wrapDirection: #none.
	addressBox setProperty: #objectName toValue: 'addressBox'.
	addressBox setProperty: #objectDescription toValue: 'No description given.'.
	addressLabel := UiLabel new.
	addressLabel changeTableLayout.
	addressLabel extent: 51@18.
	addressLabel position: 926@193.
	addressLabel hResizing: #shrinkWrap.
	addressLabel vResizing: #shrinkWrap.
	addressLabel cellInset: 0.
	addressLabel cellPositioning: #center.
	addressLabel cellSpacing: #none.
	addressLabel layoutInset: 0.
	addressLabel listCentering: #topLeft.
	addressLabel listDirection: #leftToRight.
	addressLabel listSpacing: #none.
	addressLabel maxCellSize: 1073741823.
	addressLabel minCellSize: 0.
	addressLabel wrapCentering: #topLeft.
	addressLabel wrapDirection: #none.
	addressLabel text: 'Address'.
	addressLabel setProperty: #objectName toValue: 'addressLabel'.
	addressLabel setProperty: #objectDescription toValue: 'No description given.'.
	addressBox addMorphBack: addressLabel.
	morphy2 := UiContainer new.
	morphy2 changeTableLayout.
	morphy2 extent: 250@30.
	morphy2 position: 826@215.
	morphy2 hResizing: #spaceFill.
	morphy2 vResizing: #shrinkWrap.
	morphy2 cellInset: 4.
	morphy2 cellPositioning: #center.
	morphy2 cellSpacing: #none.
	morphy2 layoutInset: 4.
	morphy2 listCentering: #topLeft.
	morphy2 listDirection: #leftToRight.
	morphy2 listSpacing: #none.
	morphy2 maxCellSize: 1073741823.
	morphy2 minCellSize: 0.
	morphy2 wrapCentering: #topLeft.
	morphy2 wrapDirection: #none.
	morphy2 setProperty: #objectName toValue: 'morphy2'.
	morphy2 setProperty: #objectDescription toValue: 'No description given.'.
	streetEdit := UiLineEdit new.
	streetEdit extent: 186@20.
	streetEdit position: 830@220.
	streetEdit hResizing: #spaceFill.
	streetEdit vResizing: #rigid.
	streetEdit cellInset: 0.
	streetEdit cellPositioning: #center.
	streetEdit cellSpacing: #none.
	streetEdit layoutInset: 0.
	streetEdit listCentering: #topLeft.
	streetEdit listDirection: #topToBottom.
	streetEdit listSpacing: #none.
	streetEdit maxCellSize: 1073741823.
	streetEdit minCellSize: 0.
	streetEdit wrapCentering: #topLeft.
	streetEdit wrapDirection: #none.
	streetEdit setProperty: #objectName toValue: 'streetEdit'.
	streetEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: streetEdit.
	streetNumberEdit := UiLineEdit new.
	streetNumberEdit extent: 50@20.
	streetNumberEdit position: 1020@219.
	streetNumberEdit hResizing: #rigid.
	streetNumberEdit vResizing: #rigid.
	streetNumberEdit cellInset: 0.
	streetNumberEdit cellPositioning: #center.
	streetNumberEdit cellSpacing: #none.
	streetNumberEdit layoutInset: 0.
	streetNumberEdit listCentering: #topLeft.
	streetNumberEdit listDirection: #topToBottom.
	streetNumberEdit listSpacing: #none.
	streetNumberEdit maxCellSize: 1073741823.
	streetNumberEdit minCellSize: 0.
	streetNumberEdit wrapCentering: #topLeft.
	streetNumberEdit wrapDirection: #none.
	streetNumberEdit setProperty: #objectName toValue: 'streetNumberEdit'.
	streetNumberEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy2 addMorphBack: streetNumberEdit.
	addressBox addMorphBack: morphy2.
	morphy3 := UiContainer new.
	morphy3 changeTableLayout.
	morphy3 extent: 250@30.
	morphy3 position: 826@249.
	morphy3 hResizing: #spaceFill.
	morphy3 vResizing: #shrinkWrap.
	morphy3 cellInset: 4.
	morphy3 cellPositioning: #center.
	morphy3 cellSpacing: #none.
	morphy3 layoutInset: 4.
	morphy3 listCentering: #topLeft.
	morphy3 listDirection: #leftToRight.
	morphy3 listSpacing: #none.
	morphy3 maxCellSize: 1073741823.
	morphy3 minCellSize: 0.
	morphy3 wrapCentering: #topLeft.
	morphy3 wrapDirection: #none.
	morphy3 setProperty: #objectName toValue: 'morphy3'.
	morphy3 setProperty: #objectDescription toValue: 'No description given.'.
	postalEdit := UiLineEdit new.
	postalEdit extent: 80@20.
	postalEdit position: 830@253.
	postalEdit hResizing: #rigid.
	postalEdit vResizing: #rigid.
	postalEdit cellInset: 0.
	postalEdit cellPositioning: #center.
	postalEdit cellSpacing: #none.
	postalEdit layoutInset: 0.
	postalEdit listCentering: #topLeft.
	postalEdit listDirection: #topToBottom.
	postalEdit listSpacing: #none.
	postalEdit maxCellSize: 1073741823.
	postalEdit minCellSize: 0.
	postalEdit wrapCentering: #topLeft.
	postalEdit wrapDirection: #none.
	postalEdit setProperty: #objectName toValue: 'postalEdit'.
	postalEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: postalEdit.
	townEdit := UiLineEdit new.
	townEdit extent: 156@20.
	townEdit position: 916@254.
	townEdit hResizing: #spaceFill.
	townEdit vResizing: #rigid.
	townEdit cellInset: 0.
	townEdit cellPositioning: #center.
	townEdit cellSpacing: #none.
	townEdit layoutInset: 0.
	townEdit listCentering: #topLeft.
	townEdit listDirection: #topToBottom.
	townEdit listSpacing: #none.
	townEdit maxCellSize: 1073741823.
	townEdit minCellSize: 0.
	townEdit wrapCentering: #topLeft.
	townEdit wrapDirection: #none.
	townEdit setProperty: #objectName toValue: 'townEdit'.
	townEdit setProperty: #objectDescription toValue: 'No description given.'.
	morphy3 addMorphBack: townEdit.
	addressBox addMorphBack: morphy3.
	morph5 addMorphBack: addressBox.
	morph10 := UiContainer new.
	morph10 changeTableLayout.
	morph10 extent: 250@488.
	morph10 position: 826@284.
	morph10 hResizing: #spaceFill.
	morph10 vResizing: #spaceFill.
	morph10 cellInset: 4.
	morph10 cellPositioning: #center.
	morph10 cellSpacing: #none.
	morph10 layoutInset: 0.
	morph10 listCentering: #topLeft.
	morph10 listDirection: #topToBottom.
	morph10 listSpacing: #none.
	morph10 maxCellSize: 1073741823.
	morph10 minCellSize: 0.
	morph10 wrapCentering: #topLeft.
	morph10 wrapDirection: #none.
	morph10 setProperty: #objectName toValue: 'morph10'.
	morph10 setProperty: #objectDescription toValue: 'No description given.'.
	morph11 := UiContainer new.
	morph11 changeTableLayout.
	morph11 extent: 250@26.
	morph11 position: 826@284.
	morph11 hResizing: #spaceFill.
	morph11 vResizing: #shrinkWrap.
	morph11 cellInset: 4.
	morph11 cellPositioning: #center.
	morph11 cellSpacing: #none.
	morph11 layoutInset: 4.
	morph11 listCentering: #topLeft.
	morph11 listDirection: #leftToRight.
	morph11 listSpacing: #none.
	morph11 maxCellSize: 1073741823.
	morph11 minCellSize: 0.
	morph11 wrapCentering: #topLeft.
	morph11 wrapDirection: #none.
	morph11 setProperty: #objectName toValue: 'morph11'.
	morph11 setProperty: #objectDescription toValue: 'No description given.'.
	friendsLabel := UiLabel new.
	friendsLabel changeTableLayout.
	friendsLabel extent: 10@18.
	friendsLabel position: 830@288.
	friendsLabel hResizing: #shrinkWrap.
	friendsLabel vResizing: #shrinkWrap.
	friendsLabel cellInset: 0.
	friendsLabel cellPositioning: #center.
	friendsLabel cellSpacing: #none.
	friendsLabel layoutInset: 0.
	friendsLabel listCentering: #topLeft.
	friendsLabel listDirection: #leftToRight.
	friendsLabel listSpacing: #none.
	friendsLabel maxCellSize: 1073741823.
	friendsLabel minCellSize: 0.
	friendsLabel wrapCentering: #topLeft.
	friendsLabel wrapDirection: #none.
	friendsLabel text: 'O'.
	friendsLabel setProperty: #objectName toValue: 'friendsLabel'.
	friendsLabel setProperty: #objectDescription toValue: 'No description given.'.
	morph11 addMorphBack: friendsLabel.
	morph13 := UiLabel new.
	morph13 changeTableLayout.
	morph13 extent: 44@18.
	morph13 position: 844@288.
	morph13 hResizing: #shrinkWrap.
	morph13 vResizing: #shrinkWrap.
	morph13 cellInset: 0.
	morph13 cellPositioning: #center.
	morph13 cellSpacing: #none.
	morph13 layoutInset: 0.
	morph13 listCentering: #topLeft.
	morph13 listDirection: #leftToRight.
	morph13 listSpacing: #none.
	morph13 maxCellSize: 1073741823.
	morph13 minCellSize: 0.
	morph13 wrapCentering: #topLeft.
	morph13 wrapDirection: #none.
	morph13 text: 'Friends'.
	morph13 setProperty: #objectName toValue: 'morph13'.
	morph13 setProperty: #objectDescription toValue: 'No description given.'.
	morph11 addMorphBack: morph13.
	morph10 addMorphBack: morph11.
	friendsList := UiListWidget new.
	friendsList extent: 250@424.
	friendsList position: 826@314.
	friendsList hResizing: #spaceFill.
	friendsList vResizing: #spaceFill.
	friendsList cellInset: 0.
	friendsList cellPositioning: #center.
	friendsList cellSpacing: #none.
	friendsList layoutInset: 0.
	friendsList listCentering: #topLeft.
	friendsList listDirection: #topToBottom.
	friendsList listSpacing: #none.
	friendsList maxCellSize: 1073741823.
	friendsList minCellSize: 0.
	friendsList wrapCentering: #topLeft.
	friendsList wrapDirection: #none.
	friendsList setProperty: #objectName toValue: 'friendsList'.
	friendsList setProperty: #objectDescription toValue: 'No description given.'.
	morph10 addMorphBack: friendsList.
	morph14 := UiContainer new.
	morph14 changeTableLayout.
	morph14 extent: 250@29.
	morph14 position: 826@743.
	morph14 hResizing: #spaceFill.
	morph14 vResizing: #shrinkWrap.
	morph14 cellInset: 4.
	morph14 cellPositioning: #center.
	morph14 cellSpacing: #none.
	morph14 layoutInset: 0.
	morph14 listCentering: #topLeft.
	morph14 listDirection: #leftToRight.
	morph14 listSpacing: #none.
	morph14 maxCellSize: 1073741823.
	morph14 minCellSize: 0.
	morph14 wrapCentering: #topLeft.
	morph14 wrapDirection: #none.
	morph14 setProperty: #objectName toValue: 'morph14'.
	morph14 setProperty: #objectDescription toValue: 'No description given.'.
	friendCombo := UiComboBox new.
	friendCombo changeTableLayout.
	friendCombo extent: 149@22.
	friendCombo position: 826@747.
	friendCombo hResizing: #spaceFill.
	friendCombo vResizing: #shrinkWrap.
	friendCombo cellInset: 0.
	friendCombo cellPositioning: #center.
	friendCombo cellSpacing: #none.
	friendCombo layoutInset: 0.
	friendCombo listCentering: #topLeft.
	friendCombo listDirection: #leftToRight.
	friendCombo listSpacing: #none.
	friendCombo maxCellSize: 1073741823.
	friendCombo minCellSize: 0.
	friendCombo wrapCentering: #topLeft.
	friendCombo wrapDirection: #none.
	friendCombo setProperty: #objectName toValue: 'friendCombo'.
	friendCombo setProperty: #objectDescription toValue: 'No description given.'.
	morph14 addMorphBack: friendCombo.
	addFriendButton := UiPushButton new.
	addFriendButton changeTableLayout.
	addFriendButton extent: 95@28.
	addFriendButton position: 979@743.
	addFriendButton hResizing: #shrinkWrap.
	addFriendButton vResizing: #shrinkWrap.
	addFriendButton cellInset: 4.
	addFriendButton cellPositioning: #center.
	addFriendButton cellSpacing: #none.
	addFriendButton layoutInset: 4.
	addFriendButton listCentering: #topLeft.
	addFriendButton listDirection: #leftToRight.
	addFriendButton listSpacing: #none.
	addFriendButton maxCellSize: 1073741823.
	addFriendButton minCellSize: 0.
	addFriendButton wrapCentering: #topLeft.
	addFriendButton wrapDirection: #none.
	addFriendButton text: 'Add Friend'.
	addFriendButton setProperty: #objectName toValue: 'addFriendButton'.
	addFriendButton setProperty: #objectDescription toValue: 'No description given.'.
	morph14 addMorphBack: addFriendButton.
	morph10 addMorphBack: morph14.
	morph5 addMorphBack: morph10.
	panel addMorphBack: morph5.
	panel setProperty: #uiClassName toValue: 'SyAddressBook2'.! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:15.805'!
morph1
	"No description given."
	
	^ morph1! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.822'!
morph10
	"No description given."
	
	^ morph10! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.856'!
morph11
	"No description given."
	
	^ morph11! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.93'!
morph13
	"No description given."
	
	^ morph13! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:17.015'!
morph14
	"No description given."
	
	^ morph14! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:15.865'!
morph2
	"No description given."
	
	^ morph2! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:15.939'!
morph3
	"No description given."
	
	^ morph3! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.016'!
morph4
	"No description given."
	
	^ morph4! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.173'!
morph5
	"No description given."
	
	^ morph5! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.214'!
morph6
	"No description given."
	
	^ morph6! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.248'!
morph7
	"No description given."
	
	^ morph7! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.365'!
morph8
	"No description given."
	
	^ morph8! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.439'!
morph9
	"No description given."
	
	^ morph9! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.597'!
morphy2
	"No description given."
	
	^ morphy2! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.706'!
morphy3
	"No description given."
	
	^ morphy3! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:15.981'!
personList
	"No description given."
	
	^ personList! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:15.913'!
personsLabel
	"No description given."
	
	^ personsLabel! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.747'!
postalEdit
	"No description given."
	
	^ postalEdit! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.064'!
silentButton
	"No description given."
	
	^ silentButton! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.098'!
spacer
	"No description given."
	
	^ spacer! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.631'!
streetEdit
	"No description given."
	
	^ streetEdit! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.672'!
streetNumberEdit
	"No description given."
	
	^ streetNumberEdit! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.323'!
surnameEdit
	"No description given."
	
	^ surnameEdit! !

!SyAddressBook2Ui methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:16.781'!
townEdit
	"No description given."
	
	^ townEdit! !

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'testing' stamp: 'SR 6/3/2010 14:18:00.28'!
isConnected
	"Fix socket bug under windows. Trigger a new receive operation to force status update in the plugin."
	
	[
		self adjustInBuffer: (self socket
			receiveDataNonBlockingInto: inBuffer
			startingAt: inNextToWrite).
		^ self socket isConnected]
	on: Exception
	do: [^ false]! !

!SyTcpSocket methodsFor: 'stream out' stamp: 'SR 6/3/2010 14:14:51.528'!
nextPutAll: aCollection
	"Overridden to be better testable with a normal stream. Use the optimized version #nextPutAllFlush:."
	
	^ self isConnected
		ifTrue: [self nextPutAllFlush: aCollection]
		ifFalse: [nil]! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:34:56.652'!
remoteAddressString

	^ NetNameResolver stringFromAddress: self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:36:39.6'!
remoteID

	^ self remoteAddressString, ':', self remotePort asString! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

Morph subclass: #SyAddressBook2
	instanceVariableNames: 'ui client persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook'!

!SyAddressBook2 class methodsFor: 'demo' stamp: 'mt 7/21/2010 21:35:22.509'!
addDemoDataTo: aSyServer

	| personList |
	personList := PersonList new.
	aSyServer repository rootObject: personList.
	
	aSyServer repository register: (personList addPerson: (Person givenName: 'Robbert' surname: 'Kran')).
	aSyServer repository register: (personList addPerson: (Person givenName: 'Stefan' surname: 'Richter')).
	
	personList persons first address: (aSyServer repository register: (SyAddress new town: 'Munich')) client.
	personList persons second address: (aSyServer repository register: (SyAddress new town: 'Potsdam')) client..
	! !

!SyAddressBook2 class methodsFor: 'opening' stamp: 'mt 7/21/2010 20:07:42.147'!
open

	self new open! !

!SyAddressBook2 class methodsFor: 'demo' stamp: 'mt 7/21/2010 20:07:20.353'!
openClient

	| instance |
	instance := self basicNew.
	instance connectToHostNamed: 'localhost' port: 22701.
	instance initialize.
	^ instance open! !

!SyAddressBook2 class methodsFor: 'demo' stamp: 'mt 7/21/2010 20:07:57.721'!
openDemo

	| srv |
	srv := SyServer new start.
	
	self addDemoDataTo: srv.
	
	self openClient topLeft: 0@0.
	self openClient topLeft: 500@0.
	
	srv explore. "Close server manually."
	! !

!SyAddressBook2 class methodsFor: 'demo' stamp: 'mt 7/21/2010 21:04:37.135'!
openDemoPrimary

	| srv |
	srv := SyServer new start.
	
	self addDemoDataTo: srv.
	
	self openClient topLeft: 0@0.
	
	srv explore. "Close server manually."
	! !

!SyAddressBook2 class methodsFor: 'demo' stamp: 'mt 7/21/2010 21:04:47.696'!
openDemoSecondary

	self openClient topLeft: 0@0.! !

!SyAddressBook2 methodsFor: 'actions' stamp: 'mt 7/21/2010 19:49:21.749'!
addFriend

	| newFriend person |
	newFriend := self persons persons
		detect: [:p | (p givenName, ' ', p surname) = self ui friendCombo currentText asString]
		ifNone: [^ self].
		
	person := (self persons persons at: self ui personList currentRow).
	person addFriend: newFriend.! !

!SyAddressBook2 methodsFor: 'updating - friend list' stamp: 'mt 7/21/2010 19:49:27.285'!
addFriendToPerson: aPerson

	(self ui friendsList labels includes: (aPerson givenName, ' ', aPerson surname))
		ifTrue: [^ self].
		
	self ui friendsList addText: aPerson givenName, ' ', aPerson surname.
	self updateFriendCombo.! !

!SyAddressBook2 methodsFor: 'actions' stamp: 'mt 7/21/2010 18:30:18.375'!
addPerson

	| person |
	person := Person givenName: 'Max' surname: 'Mustermann'.
	self persons addPerson: person.
	person address: SyAddress new.! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 21:18:17.693'!
addPersonToList: aPerson

	self ui personList addText: aPerson givenName, ' ', aPerson surname.
	
	self connect: aPerson signal: #givenName: toSelector: #updateAllListItems.
	self connect: aPerson signal: #surname: toSelector: #updateAllListItems.
	self connect: aPerson signal: #birthday: toSelector: #updateAllListItems.
	! !

!SyAddressBook2 methodsFor: 'actions' stamp: 'mt 7/21/2010 20:56:17.44'!
changeSilentMode: enabled

	client ifNil: [^ self "Do nothing in offline mode."].

	enabled
		ifTrue: [client deferSends]
		ifFalse: [client dontDeferSends]! !

!SyAddressBook2 methodsFor: 'networking' stamp: 'mt 7/21/2010 20:19:24.939'!
connectToHostNamed: aHost port: aPort

	client ifNotNil: [:c | c disconnect].
	client := SyClient new.
	client connectToHostNamed: aHost port: aPort.
	self connect: client signal: #rebooted toSelector: #processClientReboot.
	
	persons := client repository rootObject.! !

!SyAddressBook2 methodsFor: 'initialization' stamp: 'mt 7/21/2010 20:52:11.438'!
initialize

	super initialize.
	self ui setupUi: self.
	
	self
		color: (Color gray: 0.8);
		width: 500;
		height: 350.

	self ui personsLabel form: UiSilkIcons groupIcon.
	self ui friendsLabel form: UiSilkIcons groupLinkIcon.
	self ui birthdayLabel form: UiSilkIcons cakeIcon.

	self ui addPersonButton icon: UiSilkIcons userAddIcon.
	self ui addFriendButton icon: UiSilkIcons userGoIcon.
	(self ui silentButton)
		icon: nil. "UiSilkIcons statusOfflineIcon;"

	self connect: self ui silentButton signal: #toggled: toSelector: #changeSilentMode:.
	
	self ui addressBox color: (Color gray: 0.7).
	
	self ui personList autoDeselect: false.
	
	self initializePersons.! !

!SyAddressBook2 methodsFor: 'initialization' stamp: 'mt 7/21/2010 20:23:41.689'!
initializePersons
	"Decide whether to operate online or offline."
	
	"TODO: set client"
	
	self connect: self ui addPersonButton signal: #clicked: toSelector: #addPerson.
	self connect: self persons signal: #addPerson: toSelector: #addPersonToList:.
	self connect: self ui personList signal: #currentRowChanged: toSelector: #updateCurrentSelection:.
	
	self connect: self ui givenNameEdit signal: #textEdited: toSelector: #updateGivenName:.
	self connect: self ui surnameEdit signal: #textEdited: toSelector: #updateSurname:.
	self connect: self ui birthdayEdit signal: #textEdited: toSelector: #updateBirthday:.
	self connect: self ui streetEdit signal: #textEdited: toSelector: #updateAddressStreet:.
	self connect: self ui streetNumberEdit signal: #textEdited: toSelector: #updateAddressStreetNumber:.
	self connect: self ui postalEdit signal: #textEdited: toSelector: #updateAddressPostalCode:.
	self connect: self ui townEdit signal: #textEdited: toSelector: #updateAddressTown:.
	
	self connect: self ui addFriendButton signal: #clicked: toSelector: #addFriend.
	
	self updatePersonList.
	self ui personList currentRow: 1.! !

!SyAddressBook2 methodsFor: 'initialization' stamp: 'mt 7/21/2010 20:09:54.547'!
open

	| window |
	window := (self openInWindowLabeled: 'Address Book')
		model: self.
		
	self color: (Color gray: 0.8).
	^ window! !

!SyAddressBook2 methodsFor: 'accessing' stamp: 'mt 7/21/2010 12:24:50.683'!
persons

	^ persons ifNil: [persons := PersonList new]! !

!SyAddressBook2 methodsFor: 'networking' stamp: 'mt 7/21/2010 21:05:11.649'!
processClientReboot

	persons := client repository rootObject.
	self updatePersonList.
	self ui personList currentRow: 1.
	self ui silentButton checked: false.
	
	UserDialogBoxMorph inform: 'Client rebooted. Local changes got lost.' title: 'Conflict detected!!' at: self center.! !

!SyAddressBook2 methodsFor: 'networking' stamp: 'mt 7/21/2010 20:04:44.177'!
release
	"Callback when window is closed."
	
	client ifNotNil: [:c | c disconnect.].
	Transcript cr; show: 'AddressBook client closed successfully.'.! !

!SyAddressBook2 methodsFor: 'accessing' stamp: 'mt 7/21/2010 20:46:23.866'!
ui

	^ ui ifNil: [ui := SyAddressBook2Ui new] ! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 18:42:50.977'!
updateAddressPostalCode: aString

	| person |
	person := self persons persons at: self ui personList currentRow.

	person address disconnectSignal: #postalCode:.
	person address postalCode: aString.
	self connect: person address signal: #postalCode: to: self ui postalEdit selector: #theText:.	! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 18:42:45.552'!
updateAddressStreet: aString

	| person |
	person := self persons persons at: self ui personList currentRow.

	person address disconnectSignal: #street:.
	person address street: aString.
	self connect: person address signal: #street: to: self ui streetEdit selector: #theText:.	! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 18:42:40.017'!
updateAddressStreetNumber: aString

	| person |
	person := self persons persons at: self ui personList currentRow.
	
	person address disconnectSignal: #streetNo:.
	person address streetNo: aString.
	self connect: person address signal: #streetNo: to: self ui streetNumberEdit selector: #theText:.	! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 18:43:13.161'!
updateAddressTown: aString

	| person |
	person := self persons persons at: self ui personList currentRow.
	
	person address disconnectSignal: #town:.
	person address town: aString.
	self connect: person address signal: #town: to: self ui townEdit selector: #theText:.	! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 18:50:18.026'!
updateAllListItems

	self persons persons withIndexDo: [:person :index |
		(self ui personList items at: index)
			text: (person givenName, ' ', person surname);
			icon: (person birthday ifNotNil: [UiSilkIcons cakeIcon])].! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 19:21:39.343'!
updateBirthday: aString

	| person |
	person := self persons persons at: self ui personList currentRow.
	
	person disconnectSignal: #birthday:.
	person birthday: (aString isEmpty ifTrue: [nil] ifFalse: [aString asString]).
	self connect: person signal: #birthday: to: self ui birthdayEdit selector: #theText:.
	self connect: person signal: #birthday: toSelector: #updateAllListItems.
	
	self updateCurrentListItem.! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 18:14:51.059'!
updateCurrentListItem

	| person |
	person := self persons persons at: self ui personList currentRow.
	(self ui personList currentItem)
		text: (person givenName, ' ', person surname);
		icon: (person birthday ifNotNil: [UiSilkIcons cakeIcon]).! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 19:54:20.588'!
updateCurrentSelection: anIndex

	| person |
	(anIndex = 0 or: [anIndex > self persons persons size]) ifTrue: [^ self].
	
	person := self persons persons at: anIndex.
	self ui givenNameEdit theText: person givenName.
	self ui surnameEdit theText: person surname.
	self ui birthdayEdit theText: (person birthday ifNil: ['']).
	
	self ui streetEdit theText: person address street.
	self ui streetNumberEdit theText: person address streetNo.
	self ui postalEdit theText: person address postalCode.
	self ui townEdit theText: person address town .
	
	self updateFriendCombo.
	self updateFriendList.
	
	self persons persons do: [:p | p disconnectAllSignals].
	self connect: person signal: #givenName: to: self ui givenNameEdit selector: #theText:.
	self connect: person signal: #surname: to: self ui surnameEdit selector: #theText:.
	self connect: person signal: #birthday: to: self ui birthdayEdit selector: #theText:.

	self connect: person address signal: #street: to: self ui streetEdit selector: #theText:.
	self connect: person address signal: #streetNo: to: self ui streetNumberEdit selector: #theText:.
	self connect: person address signal: #postalCode: to: self ui postalEdit selector: #theText:.
	self connect: person address signal: #town: to: self ui townEdit selector: #theText:.
	
	self persons persons do: [:p | 
		self connect: p signal: #givenName: toSelector: #updateAllListItems.
		self connect: p signal: #surname: toSelector: #updateAllListItems.
		self connect: p signal: #birthday: toSelector: #updateAllListItems.].
	
	self connect: person signal: #addFriend: toSelector: #addFriendToPerson:.! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 19:29:31.182'!
updateFriendCombo

	| person |
	person := self persons persons at: self ui personList currentRow.
	
	self ui friendCombo clear.
	self persons persons
		reject: [:p | (person friends includes: p) or: [p == person]]
		thenDo: [:p | self ui friendCombo addText: (p givenName, ' ', p surname) ].! !

!SyAddressBook2 methodsFor: 'updating - friend list' stamp: 'mt 7/21/2010 19:38:36.144'!
updateFriendList

	| person |
	person := self persons persons at: self ui personList currentRow.
	self ui friendsList clear.
	person friends do: [:p |
		self ui friendsList addText: p givenName, ' ', p surname].! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 19:21:17.729'!
updateGivenName: aString

	| person |
	person := self persons persons at: self ui personList currentRow.

	person disconnectSignal: #givenName:.
	person givenName: aString asString.
	self connect: person signal: #givenName: to: self ui givenNameEdit selector: #theText:.
	self connect: person signal: #givenName: toSelector: #updateAllListItems.

	self updateCurrentListItem.! !

!SyAddressBook2 methodsFor: 'updating - person list' stamp: 'mt 7/21/2010 19:53:28.866'!
updatePersonList

	self ui personList clear.
	self persons persons do: [:p |
		self ui personList addText: p givenName, ' ', p surname].! !

!SyAddressBook2 methodsFor: 'private' stamp: 'mt 7/21/2010 19:21:28.493'!
updateSurname: aString

	| person |
	person := self persons persons at: self ui personList currentRow.
	
	person disconnectSignal: #surname:.
	person surname: aString asString.
	self connect: person signal: #surname: to: self ui surnameEdit selector: #theText:.
	self connect: person signal: #surname: toSelector: #updateAllListItems.

	self updateCurrentListItem.! !

Model subclass: #SyAddressBook
	instanceVariableNames: 'persons personListIndex client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook'!

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:53:12.827'!
addDemoDataTo: aSyServer

	| personList |
	personList := PersonList new.
	aSyServer repository rootObject: personList.
	
	aSyServer repository register: (personList addPerson: (Person givenName: 'Bastian' surname: 'Steinert')).
	aSyServer repository register: (personList addPerson: (Person givenName: 'Malte' surname: 'Appeltauer')).
	aSyServer repository register: (personList addPerson: (Person givenName: 'Michael' surname: 'Perscheid')).
	
	personList persons first address: 'Berlin'.
	personList persons second address: 'Berlin'.
	personList persons third address: 'Potsdam'.
	
		.! !

!SyAddressBook class methodsFor: 'opening' stamp: 'rkrk 6/20/2010 15:44:31.441'!
open

	self new open! !

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:42:04.278'!
openClient

	| instance window |
	instance := self new.
	instance connectToHostNamed: 'localhost' port: 22701.
	window := instance open.
	^ window	.! !

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:51:02.293'!
openDemo

	| srv |
	srv := SyServer new start.
	
	self addDemoDataTo: srv.
	
	self openClient topLeft: 0@0.
	self openClient topLeft: 500@0.
	
	srv explore. "Close server manually."
	
	
		.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 01:16:29.412'!
addFriend

	| person friend |
	person := self selectedPerson.
	person ifNil: [^self].
	friend := self requestPerson.
	friend ifNil: [
		self inform: 'Cannot find this person in address book!!'.
		^self].
	friend == person ifTrue: [
		self inform: 'Cannot add a person as her/his own friend'.
		^self].
	person addFriend: friend.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:39:52.407'!
addPerson

	| givenName lastName |
	givenName := self request: 'Please enter given name' initialAnswer: ''.
	lastName := self request: 'Please enter last name' initialAnswer: ''.
	(lastName isEmpty or: [givenName isEmpty]) ifTrue: [^self].
	self createAndAddPerson: givenName lastName: lastName.
	self changed: #personList.! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 18:35:18.696'!
buildButtonsWith: builder
			
	| panelSpec buttonSpec addButtonNo addButtonFrames editButtonNo editButtonFrames incr defaultRect |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	addButtonNo := 2.
	incr := 0.5 / addButtonNo.
	defaultRect := 0@0 corner: incr@1.
	addButtonFrames := (0 to: addButtonNo-1) collect: [:i | defaultRect translateBy: i*incr@0].

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'Refresh'; 
			state: nil;
			action: #refresh;
			frame: (addButtonFrames at: 1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'add person'; 
			state: #canAddPerson;
			action: #addPerson;
			frame: (addButtonFrames at: 2).
	panelSpec children addLast: buttonSpec.

	editButtonNo := 3.
	incr := 0.5 / editButtonNo.
	defaultRect := 0.5@0 corner: 0.5+incr@1.
	editButtonFrames := (0 to: editButtonNo-1) collect: [:i | defaultRect translateBy: i*incr@0].
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'edit address';
			state: #canEditAddress;
			action: #editAddress;
			frame: (editButtonFrames at: 1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'edit birthday';
			state: #canEditBirthday;
			action: #editBirthday;
			frame: (editButtonFrames at: 2).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'add friend';
			state: #canAddFriend;
			action: #addFriend;
			frame: (editButtonFrames at: 3).
	panelSpec children addLast: buttonSpec.
	
	^panelSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:18:50.737'!
buildPersonDetailsWith: builder

	| textSpec |
	textSpec := builder pluggableTextSpec new.
	textSpec 
		model: self;
		getText: #personDetails.
		"setText: #contents:notifying:;
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:."
	^textSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:08:38.91'!
buildPersonListWith: builder

	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #personList;
		getIndex: #personListIndex;
		setIndex: #personListIndex:.
		"menu: #classListMenu:shifted:; "
		"keyPress: #classListKey:from:."
	^listSpec
! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 16:48:59.013'!
buildWindowWith: builder

	"copied from StringHolder"
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: #labelString.
	windowSpec children: OrderedCollection new.
	windowSpec closeAction: #close.
	^windowSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 14:58:34.483'!
buildWindowWith: builder specs: specs

	"copied from StringHolder"
	| windowSpec |
	windowSpec := self buildWindowWith: builder.
	specs do:[:assoc|
		| rect action widgetSpec |
		rect := assoc key.
		action := assoc value.
		widgetSpec := action value.
		widgetSpec ifNotNil:[
			widgetSpec frame: rect.
			windowSpec children add: widgetSpec]].
	^windowSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:15:48.429'!
buildWith: builder

	^ self buildWindowWith: builder specs: {
			(0@0 corner: 0.5@0.9) -> [self buildPersonListWith: builder].
			(0@0.9 corner: 1@1) -> [self buildButtonsWith: builder].
			(0.5@0 corner: 1@0.9) -> [self buildPersonDetailsWith: builder].
			"(0.34@0.06 corner: 0.67@0.34) -> [self buildMessageCategoryListWith: builder].
			(0.67@0.06 corner: 1.0@0.34) -> [self buildMessageListWith: builder].
			(0.0@0.34 corner: 1.0@0.9) -> [self buildCodePaneWith: builder].
			(0.0@0.9 corner: 1.0@1.0) -> [self buildInfoViewWith: builder]"
			}! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:55:00.52'!
canAddFriend

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:12:29.418'!
canAddPerson

	^ true! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:17:11.801'!
canEditAddress

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:54:54.548'!
canEditBirthday

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 7/21/2010 20:04:27.451'!
close
	"Callback when window is closed."
	
	client ifNotNil: [:c | c disconnect.].
	Transcript cr; show: 'AddressBook client closed successfully.'.! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 6/22/2010 17:34:55.386'!
connectToHostNamed: aHost port: aPort

	client ifNotNil: [:c | c disconnect].
	client := SyClient new.
	client connectToHostNamed: aHost port: aPort.
	
	self changed: #personList.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'mt 6/22/2010 17:33:50.398'!
createAndAddPerson: givenName lastName: lastName

	| p |
	p := Person givenName: givenName surname: lastName.
	
	client
		ifNil: [self persons add: p]
		ifNotNil: [client repository rootObject addPerson: p].! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:36:06.042'!
editAddress

	| person address |
	person := self selectedPerson.
	person ifNil: [^self].
	address := person address.
	(address isNil or: [address isString]) ifTrue: [address := SyAddress new].
	person address: (self requestAddressUsing: address).
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 01:02:49.206'!
editBirthday

	| person birthday |
	person := self selectedPerson.
	person ifNil: [^self].
	birthday := person birthday.
	(birthday isNil or: [birthday isString]) ifTrue: [birthday := Date today].
	person birthday: (self requestBirthdayUsing: birthday).
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 14:59:20.247'!
labelString
	^self class name! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 18:37:35.192'!
open

	| builder |
	builder := ToolBuilder default.
	^ (builder open: (self buildWith: builder)) extent: 500@250.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:13:32.297'!
personDetails

	self selectedPerson ifNil: [^ ''].
	^ String streamContents: [:stream |
		stream
			print: self selectedPerson; cr; cr;
			nextPutAll: 'Address:'; cr; print: self selectedPerson address; cr; cr;
			nextPutAll: 'Birthday:'; cr; print: self selectedPerson birthday; cr; cr;
			nextPutAll: 'Friends:'; cr; nextPutAll: self selectedPerson friends asCommaString].! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:39:20.517'!
personList

	^ self persons! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:45:09.007'!
personListIndex

	^ personListIndex ifNil: [personListIndex := 0]! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:08:59.214'!
personListIndex: index

	personListIndex := index.
	self changed: #personListIndex.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'accessing' stamp: 'mt 6/22/2010 17:31:53.619'!
persons

	^ client
		ifNil: [persons ifNil: [persons := OrderedCollection new]]
		ifNotNil: [client repository rootObject persons].! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 6/22/2010 18:29:20.784'!
refresh

	self changed: #personList.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'ui support' stamp: 'rkrk 6/20/2010 15:29:26.052'!
request: question initialAnswer: string

	^ UIManager default request: question initialAnswer: string.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 00:34:37.066'!
requestAddressUsing: existingAddress

	| street streetNo postalCode town |
	street := self request: 'Enter streetname' initialAnswer: existingAddress street.
	streetNo := self request: 'Enter house number' initialAnswer: existingAddress streetNo.
	postalCode := self request: 'Enter postal code' initialAnswer: existingAddress postalCode.
	town := self request: 'Enter town' initialAnswer: existingAddress town.
	"Reuse old address? Then it wouldn't be a value object..."
	^ SyAddress
		street: street
		streetNo: streetNo
		postalCode: postalCode
		town: town.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 00:44:30.391'!
requestBirthdayUsing: birthday

	| string |
	string := self request: 'Enter birthday as DD MM YYYY' initialAnswer: birthday asString.
	^ [Date readFrom: string readStream] on: Error do: [birthday].! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 01:12:42.242'!
requestPerson

	| name |
	name := self request: 'Enter first and last name of person' initialAnswer: ''.
	^ self persons
		detect: [:ea | ea asString = name]
		ifNone: [nil].
		! !

!SyAddressBook methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:09:14.441'!
selectedPerson

	^ self persons
		at: self personListIndex
		ifAbsent: [nil].! !

TestCase subclass: #SyAddressBookTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook-Test'!

!SyAddressBookTest methodsFor: 'running' stamp: 'rkrk 6/21/2010 01:35:05.829'!
setUp

	super setUp.
	sut := SyAddressBook new.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:34:51.677'!
test01CreateAddressBookAndAddPerson

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	self assert: sut persons notEmpty.
	self assert: 'Bar' equals: sut persons first surname.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:22.691'!
test02AddFriend

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut createAndAddPerson: 'Bar' lastName: 'Baz'.
	sut personListIndex: 1.
	[sut addFriend] valueSupplyingAnswers: { {'*name*'. 'Bar Baz'}}.
	self assert: sut selectedPerson friends notEmpty.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:26.024'!
test03EditBirthday

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut personListIndex: 1.
	[sut editBirthday] valueSupplyingAnswers: { {'*birthday*'. '20 10 1985'}}.
	self assert: (Date year: 1985 month: 10 day: 20) equals: sut selectedPerson birthday.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:29.203'!
test04EditAddress

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut personListIndex: 1.
	[sut editAddress] valueSupplyingAnswers: {
		{'*street*'. 'Prof.-Dr.-Helmert Str.'}.
		{'*number*'. '2-3'}.
		{'*postal*'. '14482'}.
		{'*town*'. 'Potsdam'}}.
	self assert: 'Potsdam' equals: sut selectedPerson address town.! !

TestCase subclass: #SyReferenceMappingStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:20.283'!
test01UseBlockWhenSerializing

	| result sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj | 2]).
	sut nextPut: 1.
	sut reset.
	result := sut next.
	self assert: 2 equals: result.! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:46.328'!
test02CyclicMapping

	| result sut person |
	sut := SyReferenceMappingStream mapping: SyReferenceMapping identity.
	person := Person givenName: 'Peter' surname: 'Lustig'.
	person specialFriend: person.
	sut nextPut: person.
	sut reset.
	result := sut next.
	self assert: result == result specialFriend.
! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:34:38.361'!
test03ComplexMapping

	| result person1 person2 sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj |
		((obj isKindOf: Person) and: [obj givenName = 'Fritz'])
			ifTrue: [23]
			ifFalse: [obj]]).
	person1 := Person givenName: 'Peter' surname: 'Lustig'.
	person2 := Person givenName: 'Fritz' surname: 'Fuchs'.
	person1 specialFriend: person2.
	sut nextPut: person1.
	sut reset.
	result := sut next.
	self assert: 23 == result specialFriend.
! !

TestCase subclass: #SyTestCase
	instanceVariableNames: 'syClients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyTestCase subclass: #SyClientTestCase
	instanceVariableNames: 'server sut obj1Server obj2Server obj1UUID obj2UUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 6/14/2010 18:56:49.554'!
defaultPort

	^ 22701! !

!SyClientTestCase methodsFor: 'running' stamp: 'SR 6/14/2010 18:50:46.508'!
setUp

	super setUp.
	server := SyServer new.
	obj1Server := Person givenName: 'Micha' surname: 'Test'.
	obj2Server := Person givenName: 'Christoph' surname: 'Muster'.
	obj1UUID := (server repository register: obj1Server) uuid.
	obj2UUID := (server repository register: obj2Server) uuid.
	server start.! !

!SyClientTestCase methodsFor: 'running' stamp: 'mt 7/13/2010 16:41:21.686'!
tearDown

	| errBlock |
	super tearDown.
	errBlock := [:e |
		Transcript cr;
			show: 'Error in tearDown of ' , self class , '>>#' , self selector;
			show: e].
	
	[server stop] on: Error do: errBlock.
	server repository clear.! !

SyClientTestCase subclass: #SyClientTests
	instanceVariableNames: 'spy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 7/20/2010 17:39:07.783'!
defaultTimeout

	^360! !

!SyClientTests methodsFor: 'running' stamp: 'mt 6/23/2010 16:07:15.519'!
setUp

	super setUp.
	spy := SignalSpy onSender: server signal: #commandExecuted:.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/2/2010 22:39:21.285'!
test01ConnectDisconnect

	sut := self createAndConnectClient.
	self assert: sut isConnected.
	sut disconnect.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:10:54.352'!
test02GetObjects

	sut := self createAndConnectClient.
	self assert: sut isConnected.	
	self assert: (sut repository size = 2).
	self assert: (sut repository all contains: [:o | o = obj1Server]).
	self assert: (sut repository all contains: [:o | o = obj2Server]).! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 8/24/2010 22:46:51.041'!
test03ServerAppliesClientOperation

	| objClient |
	sut := self createAndConnectClient.
	objClient := sut repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	
	self waitFor: SyApplyCommand.
	self waitForSeconds: 1.
	
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 8/24/2010 22:46:50.991'!
test04OtherClientAppliesClientOperation

	| objClient1 objClient2 client1 client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	self assert: {client1. client2.} asSet equals: (objClient1 class >> #givenName:) allSyClients asSet.
	objClient1 givenName: 'Hans'.
	
	self waitForSeconds: 1.
	
	self assert: 'Hans' equals: objClient1 givenName.
	self assert: 'Hans' equals: objClient2 givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 7/20/2010 12:08:08.525'!
test05VersionsAfterListCommand

	| obj ro roAtClient |
	"Register a new object and perform an operation."
	obj := Person givenName: 'Peter' surname: 'Klaus'.
	ro := server repository register: obj.
	(SyApplyCommand
		receiver: ro
		selector: #givenName:
		arguments: #(Micha)
		modifiedObjects: {ro}) execute: server repository.

	"Create client, fetch object with list command and verify the version."
	sut := self createAndConnectClient.
	roAtClient := sut repository registeredObjectForUUID: ro uuid.

	self
		assert: 1 equals: roAtClient versionOffset;
		assert: 1 equals: roAtClient version.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 8/24/2010 22:46:50.95'!
test06BadVersionNotReplicated

	| objClient1 objClient2 client1 client2 regObjClient1 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.

	regObjClient1 := client1 repository registeredObjectForUUID: obj1UUID.
	regObjClient1 versionOffset: 999. "Manipulate version."
	
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString.
	
	"spy := SignalSpy onSender: server signal: #connectionsChanged."
	objClient1 givenName: 'Hans'.
	
	"spy waitForNextSignal." "Client 1 disconnected."
	"spy waitForNextSignal. ""Client 1 connected again."
	
	self waitForSeconds: 2.
	self assert: 'Micha' equals: objClient2 givenName.
	
	"Check transscript for refused-message."
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString, ' (rebooted)'.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 8/24/2010 22:46:51.031'!
test07DeferSends


	| client objClient |
	client :=  self createAndConnectClient.
	client deferSends.
	objClient := client repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	self waitForSeconds: 1.
	self assert: 1 equals: client commandsNotYetSend size.
	self assert: 'Micha' equals: obj1Server givenName.
	client dontDeferSends.
	self waitForSeconds: 1.
	self assert: 0 equals: client commandsNotYetSend size.
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 8/24/2010 22:46:50.97'!
test08ServerStateIsUsedOnConflict

	"Acceptance test for Story 4 Task 2"

	| client1 client2 objClient1 objClient2 |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.
	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	client1 deferSends.
	Transcript cr; show: '#givenName: on ' , client1 asString.
	objClient1 givenName: 'Hans'.	
"	self wait: 1.
	self assert: 'Micha' equals: objClient2 givenName."

	Transcript cr; show: '#givenName: on ' , client2 asString.
	objClient2 givenName: 'Fritz'. "conflict!!"
	"client1 dontDeferSends."
	self waitForSeconds: 1.
	self assert: 'Fritz' equals: obj1Server givenName.
	self assert: 'Fritz' equals: objClient1 givenName.
	self assert: 0 equals: client1 commandsNotYetSend size. "clean up"! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.01'!
test09PersonWithBidirectionalSpecialFriend

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	
	obj1Client1 bidirectionalSpecialFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self waitForSeconds: 2.
	World doOneCycle.
	
	self
		assert: obj1Client1 specialFriend == obj2Client1;
		assert: obj2Client1 specialFriend == obj1Client1;
		assert: obj1Client2 specialFriend == obj2Client2;
		assert: obj2Client2 specialFriend == obj1Client2.! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:50.928'!
test10OperationWithNestedMethods

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 obj1Client2OpCount obj2Client2OpCount regObj1Client2 regObj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.	
	regObj1Client2 := client2 repository registeredObjectForDomainObject: obj1Client2.
	regObj2Client2 := client2 repository registeredObjectForDomainObject: obj2Client2.
	obj1Client2OpCount := regObj1Client2 operations size.
	obj2Client2OpCount := regObj2Client2 operations size.
	
	obj1Client1 bidirectionalSpecialFriend: obj2Client1.
	
	self waitForSeconds: 2.
	
	self
		assert: obj1Client2OpCount + 1 equals: regObj1Client2 operations size;
		assert: obj2Client2OpCount + 1 equals: regObj2Client2 operations size.! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:50.961'!
test11RootObjectAfterClientsConnected

	| client1 client2 obj3 obj3UUID |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj3 := Person givenName: 'Alex' surname: 'Muster'.
	client1 repository rootObject: obj3.
	
	obj3UUID := (client1 repository registeredObjectForDomainObject: obj3) uuid.

	self waitForSeconds: 2.
	
	self
		assert: client2 repository rootObject notNil;
		assert: (client2 repository registeredObjectForDomainObject: client2 repository rootObject) uuid = obj3UUID.
! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:50.94'!
test12ApplyCommandsInGuiProcess

	| client1 obj1Client1 obj1Client2 client2 methodWrapper |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.
	methodWrapper := (SyGUIProcessTestMethodWrapper on: #perform:withArguments: inClass: Object) install.
	
	obj1Client1 := client1 repository resolve: obj1UUID.
	obj1Client2 := client2 repository resolve: obj1UUID.
	
	obj1Client1 givenName: 'Hans'.
	
	self waitForSeconds: 2.
	World doOneCycle.
	
	methodWrapper uninstall.
	self
		assert: 'Hans' equals: obj1Client2 givenName;
		assert: methodWrapper isGuiProcess.

! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.001'!
test13aVersionCountWhenOneObjectIsModified
	"Versions are counted per object. We apply a change and then send the ApplyCommand to the server.
	Only when the server acknowledges the command we count up."

	| client1 obj regObj |
	client1 := self createAndConnectClient.

	obj := client1 repository resolve: obj1UUID.
	regObj := client1 repository registeredObjectForDomainObject: obj.
	obj givenName: 'Hans'.
	
	self assert: 0 equals: regObj version. "first counted up after send"
	self waitForSeconds: 1.
	self assert: 1 equals: regObj version.! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:50.981'!
test13bVersionCountWhenOneObjectIsIndirectlyModified
	"We send a message to one object that invokes a state change at another object. The version of the
	former object shouldn't change, the other one should have an increased versiom"

	| client1 obj1 obj2 regObj1 regObj2 |
	client1 := self createAndConnectClient.

	obj1 := client1 repository resolve: obj1UUID.
	obj2 := client1 repository resolve: obj2UUID.
	regObj1 := client1 repository registeredObjectForDomainObject: obj1.
	regObj2 := client1 repository registeredObjectForDomainObject: obj2.
	obj1 specialFriend: obj2.
	obj1 changeNameOfSpecialFriend: 'Hans'.
	
	self assert: 0 equals: regObj1 version. "first counted up after send"
	self assert: 0 equals: regObj2 version. "first counted up after send"
	self waitForSeconds: 1.
	
	"self assert: 1 equals: regObj1 version." "actually, this is 2"
	self assert: 1 equals: regObj2 version.! !

!SyClientTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.02'!
test14PersonAddFriend

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	
	obj1Client1 addFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self waitForSeconds: 2.
	World doOneCycle.
	
	self
		assert: 1 equals: obj1Client1 friends size;
		assert: 1 equals: obj2Client1 friends size;
		assert: obj1Client1 friends first == obj2Client1;
		assert: obj2Client1 friends first == obj1Client1;
		assert: 1 equals: obj1Client2 friends size;
		assert: 1 equals: obj2Client2 friends size;
		assert: obj1Client2 friends first == obj2Client2;
		assert: obj2Client2 friends first == obj1Client2.! !

!SyClientTests methodsFor: 'support' stamp: 'mt 6/23/2010 16:08:36.111'!
waitFor: aCommandClass

	spy waitForNextSignalSatisfying: [:signal |
		signal second includes: aCommandClass].! !

SyClientTestCase subclass: #SyObjectReferenceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 19:03:11.274'!
test01PersonAddsSingleFriend

	| client obj1Client obj2Client |
	obj1Server specialFriend: obj2Server.
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client specialFriend == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:01:02.561'!
test02PersonWithFriendCollection

	| client obj1Client obj2Client obj3Server obj3UUID obj3Client |
	obj3Server := Person givenName: 'Robert' surname: 'Tester'.
	obj3Server
		addFriend: obj1Server;
		addFriend: obj2Server.
	obj3UUID := (server repository register: obj3Server) uuid.
	
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	obj3Client := client repository resolve: obj3UUID.
	self assert: obj3Client friends size = 2.
	self assert: obj3Client friends first == obj1Client.
	self assert: obj3Client friends second == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:00:48.793'!
test03PersonWithCyclicFriendCollection

	| client obj1Client obj2Client |
	obj1Server addFriend: obj2Server.
	obj2Server addFriend: obj1Server.
		
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client friends first == obj2Client.
	self assert: obj2Client friends first == obj1Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.07'!
test04OperationWithComplexParameter

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
		
	obj1Client1 specialFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self waitForSeconds: 2.
	
	self assert: obj1Client2 specialFriend == obj2Client2! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.08'!
test05OperationWithUnregisteredEntity

	| client1 client2 obj1Client1 obj1Client2 obj3UUID newPerson |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	
	newPerson := Person givenName: 'Marcel' surname: 'Muster'.
	obj1Client1 specialFriend: newPerson.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	
	self waitForSeconds: 2.
	
	obj3UUID := (client1 repository registeredObjectForDomainObject: obj1Client1 specialFriend) uuid.
	self
		assert: (obj1Client1 specialFriend == (client1 repository resolve: obj3UUID));
		assert: obj1Client2 specialFriend notNil;
		assert: (obj1Client2 specialFriend == (client2 repository resolve: obj3UUID)).! !

SyTestCase subclass: #SyCommandsTest
	instanceVariableNames: 'repo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommandsTest methodsFor: 'running' stamp: 'mt 7/13/2010 17:32:11.272'!
setUp

	super setUp.
	repo := SyStrongRepository new.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 12:07:38.183'!
test01CreateApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C)
		modifiedObjects: {regObj}.

	self
		assert: #(C) equals: sut arguments;
		assert: regObj uuidString equals: sut receiverUUIDString;
		assert: #givenName: equals: sut selector.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.05'!
test02ExecuteApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C)
		modifiedObjects: {regObj}.
	sut execute: repo.
	
	self waitForSeconds: 1. "wait for world ui process"
	
	self assert: 'C' equals: obj givenName.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 12:29:16.204'!
test03ApplyCommandVersions

	| sut applyCommand regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	applyCommand := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C)
		modifiedObjects: {regObj}.
		
	applyCommand execute: repo.

	"Create the real test object for this test."
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(D)
		modifiedObjects: {regObj}.

	self
		assert: 0 equals: (applyCommand modifiedObjectUUIDsAndExpectedVersions at: regObj uuid);
		assert: 1 equals: (sut modifiedObjectUUIDsAndExpectedVersions at: regObj uuid).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 13:37:37.732'!
test04ApplyCommandVersionMismatch

	| sut regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C)
		modifiedObjects: {regObj}.
		
	regObj versionOffset: 999. "A new object should have 0 and not 999."
			
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 15:30:15.614'!
test05aApplyCommandMissingReceiver

	| sut fakeRegObj notIncludedPerson |
	notIncludedPerson := Person new.
	fakeRegObj := repo register: notIncludedPerson.
	repo unregister: notIncludedPerson.
	sut := SyApplyCommand
		receiver: fakeRegObj
		selector: #nothing
		arguments: #()
		modifiedObjects: {fakeRegObj}.
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 15:29:25.238'!
test05bApplyCommandMissingModifiedObject

	| sut fakeRegObj regObj notIncludedPerson |
	regObj := repo register: Person new.
	notIncludedPerson := Person new.
	fakeRegObj := repo register: notIncludedPerson.
	repo unregister: notIncludedPerson.
	sut := SyApplyCommand
		receiver: regObj
		selector: #nothing
		arguments: #()
		modifiedObjects: {fakeRegObj}.
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'rkrk 7/20/2010 12:06:50.358'!
test06ArgumentSerialisationTest

	| sut o1 regObj |
	o1 := Person givenName: 'Max' surname: 'Muster'.
	regObj := repo register: o1.
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C)
		modifiedObjects: {regObj}. 
	
	self assert: sut arguments = #(C).
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: {o1.}
		modifiedObjects: {regObj}.
	
	self assert: sut arguments first == o1.! !

SyTestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:12:36.628'!
connectTCPClientToServer

	^ self connectTCPClientToServer: true! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:17:35.823'!
connectTCPClientToServer: shouldBeBlocking

	| spy tcpSocket |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	
	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	
	(shouldBeBlocking and: [spy notNil]) ifTrue: [spy waitForNextSignal].
	openClientSockets add: tcpSocket.
	
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:21:46.429'!
disconnectTCPClientsFromServer

	| spy |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	openClientSockets do: [:ea | 
		ea isConnected ifTrue: [
			ea close.
			spy ifNotNilDo: [:s| s waitForNextSignal]]].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'SR 6/3/2010 14:06:07.673'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 6/3/2010 14:11:29.696'!
startTcpServer

	tcpServer ifNil: [
		tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 8/24/2010 22:46:51.059'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer: false. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self waitForSeconds: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:18:50.298'!
test04TcpSocketConnection

	| tcpSocket |
	self startTcpServer.
	tcpSocket := self connectTCPClientToServer.
	self
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:12:51.446'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

SyTestCase subclass: #SyProcessBugTest
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:30.19'!
tearDown

	super tearDown.
	process ifNotNilDo: [:p | p terminate]! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:54.556'!
test01Termination

	process := [[1+1] repeat ] sqForkAt: 35.
	process suspend.
	process terminate.
	
	self assert: process isTerminated.! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 16:00:08.618'!
test02FailedTermination

	process := [[1+1] repeat ] forkAt: 35.
	process suspend.
	process terminate.
	
	self deny: process isTerminated.
	
	[process priority: 60; resume.
	Processor yield.
	process terminate] forkAt: 60.

	self assert: process isTerminated.! !

SyTestCase subclass: #SyRepositoryTests
	instanceVariableNames: 'sut o1 o2 applyCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyRepositoryTests methodsFor: 'running' stamp: 'SR 6/1/2010 09:39:19.875'!
setUp

	super setUp.
	
	sut := SyRepository new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.! !

!SyRepositoryTests methodsFor: 'running' stamp: 'mt 6/19/2010 14:59:00.996'!
tearDown

	"Unregister method wrappers."
	sut shouldCreateCommands: false.
	applyCommand := nil.
	
	^ super tearDown ! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/1/2010 09:42:02.101'!
test01UnRegisterObject

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	sut unregister: o1.
	self assert: sut isEmpty.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:21:18.382'!
test02DoubleRegistration

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	
	self
		should: [sut register: o1]
		raise: SyAlreadyRegisteredException.
! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'rkrk 7/15/2010 02:05:22.921'!
test03UnWrapObject

	| method |
	self deny: (o1 class >> #givenName:) isMwMethodWrapper.
	sut shouldCreateCommands: true.
	sut dontCreateCommandsDuring: [
		sut register: o1.
		self deny: (o1 class >> #givenName:) isMwMethodWrapper].
	method := o1 class >> #givenName:.
	self assert: method isMwMethodWrapper.
	self deny: method clientMethod isMwMethodWrapper. "just wrapped once"
	sut unregister: o1.
	self deny: (o1 class >> #givenName:) isMwMethodWrapper.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'rkrk 7/15/2010 01:20:27.437'!
test04ApplyCommandCreation

	| ro1 |
	sut shouldCreateCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self.
	
	o1 givenName: 'Peter'.
	self
		assert: ro1 uuid equals: applyCommand receiverUUID;
		assert: #givenName: equals: applyCommand selector.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:59:00.904'!
test05OperationStackTest

	| ro1 |
	sut shouldCreateCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self. "Catch apply commands in this object."
	
	self assert: ro1 operations isEmpty.
	
	o1 givenName: 'Siegbert'. "Create apply command."
	
	self assert: 0 equals: ro1 version.
		
	self
		assert: (applyCommand execute: sut); "Execute command on repository."
		assert: 1 equals: ro1 version;
		assert: ro1 version equals: ro1 operations size;
		assert: #givenName: equals: ro1 operations last selector;
		assert: {'Siegbert'} equals: ro1 operations last arguments.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/14/2010 18:43:17.76'!
test06RootObjectTest

	self assert: sut rootObject = nil.
	sut rootObject: o1.
	self assert: sut rootObject = o1	! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 11:19:37.091'!
test07CompiledMethodInstVarStoreTest

	self
		assert: (Person>>#givenName:) hasInstVarStore;
		assert: (SyRepository>>#initialize) hasInstVarStore;
		deny: (Person>>#givenName) hasInstVarStore;
		deny: (SyRepository>>#isEmpty) hasInstVarStore.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 12:02:28.433'!
test08DoNotCreateApplyCommandsForReadingMessages

	"Enable deeper call-stacks"
	o1 specialFriend: o2.
	
	"Prepare repo"
	sut shouldCreateCommands: true.
	sut register: o2.
	sut register: o1.
	sut addDependent: self.

	applyCommand := nil.
	
	"Call a couple of read-only functions"
	o1 givenName.
	self assert: applyCommand isNil.
	
	o1 specialFriend givenName.
	self assert: applyCommand isNil.
! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 12:02:20.226'!
test09DoCreateApplyCommandsForWritingMessages

	"Enable deeper call-stacks"
	o1 specialFriend: o2.
	
	"Prepare repo"
	sut shouldCreateCommands: true.
	sut register: o2.
	sut register: o1.
	sut addDependent: self.

	applyCommand := nil.
	
	"Call a couple of read-only functions"
	o1 givenName: 'Micha'.
	self assert: applyCommand notNil.

	o1 specialFriend givenName: 'Tina'.
	self assert: applyCommand notNil.	

! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 7/13/2010 15:43:42.834'!
test10Weakness

	| person |
	person := Person givenName: 'Peter' surname: 'Lustig'.
	
	sut register: person.
		
	self assert: 1 equals: sut size.
	
	person := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	self assert: sut isEmpty.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 7/13/2010 15:43:49.112'!
test11RootNotWeak

	| person |
	person := Person givenName: 'Peter' surname: 'Lustig'.
	
	sut rootObject: person.
		
	self assert: 1 equals: sut size.
	
	person := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	self assert: 1 equals: sut size.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 7/13/2010 15:43:52.978'!
test12WeaknessWithRootUsage

	| person list |
	list := PersonList new.
	person := Person givenName: 'Peter' surname: 'Lustig'.
	
	sut rootObject: list.
	sut register: person.
	
	list addPerson: person.
		
	self assert: 2 equals: sut size.
	
	list persons remove: person.
	person := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	self assert: 1 equals: sut size.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 7/13/2010 16:26:33.743'!
test13WeaknessAndResolve

	| person uuid |
	person := Person givenName: 'Peter' surname: 'Lustig'.
	uuid := (sut register: person) uuid.
	
	"Important - Nothing should be garbage collected."	
	Processor yield.
	Smalltalk garbageCollect.
	
	"There is one reference to the person. Resolving should work."
	self assert: (sut resolve: uuid) notNil.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 7/13/2010 16:47:26.138'!
test14ServerNoWeakness

	| srv person |
	srv := SyServer new.
	person := Person givenName: 'Peter' surname: 'Lustig'.
	
	srv repository register: person.
		
	self assert: 1 equals: srv repository size.
	
	person := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	self deny: srv repository isEmpty.! !

!SyRepositoryTests methodsFor: 'support' stamp: 'rkrk 7/15/2010 00:07:29.819'!
update: anAspect with: aParameter

	(anAspect = #operation) ifTrue: [applyCommand := aParameter].
	super update: anAspect with: aParameter.! !

SyTestCase subclass: #SyServerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyServerTest methodsFor: 'support' stamp: 'mt 6/19/2010 16:30:20.172'!
collectInstanceNumbers

	^ {
		#SyMethodWrapper -> SyMethodWrapper allInstances size.
		#SyClassInstrumentor -> SyClassInstrumentor allInstances size.
		#SyRepository -> SyRepository allInstances size.
		#SyServer -> SyServer allInstances size.
		#SyProtocolProcessor -> SyProtocolProcessor allInstances size.
		#Process -> Process allInstances size.
	}! !

!SyServerTest methodsFor: 'as yet unclassified' stamp: 'rkrk 7/20/2010 16:25:10.866'!
tearDown

	super tearDown.
	Person compileAll. "remove wrappers"! !

!SyServerTest methodsFor: 'tests' stamp: 'mt 6/19/2010 16:49:06.138'!
test01Finalization
	
	| server num numAfter |
	num := self collectInstanceNumbers.
	
	server := SyServer new start stop.
	server := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	numAfter := self collectInstanceNumbers.
	
	self assert: num equals: numAfter.! !

!SyServerTest methodsFor: 'tests' stamp: 'mt 6/19/2010 16:37:36.359'!
test02FinalizationWithWrappers
	
	| server num numAfter |
	num := self collectInstanceNumbers.
	
	server := SyServer new start.
	server repository register: (Person givenName: 'Stefan' surname: 'Muster').
	server repository shouldCreateCommands: true.
	server stop.
	server := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	numAfter := self collectInstanceNumbers.
	self assert: num equals: numAfter.! !

SyTestCase subclass: #SySimpleProtocolProcessorTest
	instanceVariableNames: 'sut o1 stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:10:42.257'!
clearStream

	stream := ReadWriteStream on: ''.! !

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:18:41.14'!
resetStream

	stream reset.! !

!SySimpleProtocolProcessorTest methodsFor: 'running' stamp: 'mt 5/30/2010 20:46:11.522'!
setUp

	super setUp.
	sut := SySimpleProtocolProcessor new.
	o1 := Dictionary newFrom: {
		#tag -> 'uuid'.
		#value -> UUID new asString}.
	self clearStream.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 6/15/2010 15:36:59.508'!
test01Serialization

	| serialized deserialized |
	sut objectMapping: SyReferenceMapping identity.
	serialized := sut serialize: o1 withMapping: false.
	deserialized := sut deserialize: serialized withMapping: false.
	self assert: deserialized = o1.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'SR 6/14/2010 19:36:16.865'!
test02SendingReceivingCommands

	| command process result nextCommand |

	command := SyQuitCommand new.
			
	process := [
		result := sut sendCommandBlocking: command on: stream.
	] forkAt: 60.
	
	self resetStream.
	sut processDataFrom: stream.
	
	nextCommand := sut nextCommand.
	self assert: {0. command. stream.} equals: nextCommand.
	
	self clearStream.
	sut 
		sendCommandResult: nextCommand second
		with: nextCommand first
		on: stream.
	
	self resetStream.
	sut processDataFrom: stream.
	
	Processor yield. "Let the result variable be set."

	self
		assert: (nextCommand second) equals: result;
		assert: process isTerminated.! !

SyTestCase subclass: #SySocketBugTest
	instanceVariableNames: 's1 s2 s3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySocketBugTest methodsFor: 'running' stamp: 'rkrk 5/29/2010 11:56:47.535'!
tearDown

	super tearDown.
	s1 closeAndDestroy.
	s2 closeAndDestroy.
	s3 closeAndDestroy.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:17.802'!
test01AutoDisconnection

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	self
		assert: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 == s2.

	s2 closeAndDestroy.
	s1 forceStatusUpdate.
		
	self
		deny: s2 isConnected;
		deny: s1 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:23.284'!
test02AutoDisconnectionWithServer

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345 backlogSize: 4.
	s2 connectToHostNamed: 'localhost' port:  12345.
	s3 := s1 waitForAcceptFor: 5.
	s2 waitForConnectionFor: 5.
	
	self
		deny: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 isConnected.

	s2 closeAndDestroy.
	s3 forceStatusUpdate.
		
	self
		deny: s1 isConnected;
		deny: s2 isConnected;
		deny: s3 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 13:37:50.642'!
test03StreamWorkaround
	"Check whether the workaround discards no data unexpectedly."

	| stream1 stream2 |
	
	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	
	stream1 := SyTcpSocket on: s1.
	stream2 := SyTcpSocket on: s2.
	
	stream1 nextPutAll: 'Hello!!'.
	stream2 isConnected. "This contains the workaround."
	
	self assert: 'Hello' equals: (stream2 upToAll: '!!').
! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 6/2/2010 22:35:45.655'!
createAndConnectClient

	| cl |
	cl := SyClient new
		connectToHostNamed: 'localhost'
		port: self class defaultPort.
	syClients add: cl.
	^ cl.! !

!SyTestCase methodsFor: 'support' stamp: 'mt 7/12/2010 13:06:19.857'!
performDeferredUIMessages

	[WorldState deferredUIMessages isEmpty]
		whileFalse: [WorldState deferredUIMessages next value].! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:36:46.804'!
setUp

	super setUp.
	syClients := OrderedCollection new.! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:38:01.013'!
tearDown

	super tearDown.
	syClients do: [:ea | ea disconnect].! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 8/24/2010 22:46:50.917'!
waitForSeconds: seconds

	(Delay forSeconds: seconds) wait.
	self performDeferredUIMessages. "UI process handles command execution"! !

!UndefinedObject methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:38:22.564'!
isNilOrTerminated

	^ true! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:54.1'!
sqFork

	^ self sqForkAt: Processor activeProcess priority! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:33.432'!
sqForkAt: aPriorityInteger

	^ [
		Processor activeProcess priority: aPriorityInteger.
		self value] forkAt: 60! !

!CompiledMethod methodsFor: '*SqSync' stamp: 'SR 7/11/2010 22:06:31.813'!
hasInstVarStore
	"Answer whether the method references an instance variable."

	| scanner end printer |

	scanner := InstructionStream on: self.
	printer := SyInstVarStoreLocator new.
	end := self endPC.

	[scanner pc <= end] whileTrue: [
		(printer interpretNextInstructionUsing: scanner) ifTrue: [^true].
	].
	^false! !

!Process methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:42:16.755'!
isNilOrTerminated

	^ self isTerminated! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:13:53.535'!
forceStatusUpdate
	"Workaround for broken Windows socket plugin. Better use SyTcpSocket where #isConnected will not loose any bytes if available."

	self
		receiveDataNonBlockingInto: ' '
		startingAt: 1.! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:14:08.19'!
receiveDataNonBlockingInto: aStringOrByteArray startingAt: aNumber
	"To be used to fix the status bug under Windows."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size - aNumber + 1! !

InstructionClient subclass: #SyInstVarStoreLocator
	instanceVariableNames: 'bingo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyInstVarStoreLocator methodsFor: 'initialize-release' stamp: 'SR 6/30/2010 11:11:31.211'!
interpretNextInstructionUsing: aScanner 
	
	bingo := false.
	aScanner interpretNextInstructionFor: self.
	^ bingo! !

!SyInstVarStoreLocator methodsFor: 'instruction decoding' stamp: 'SR 6/30/2010 11:15:07.048'!
popIntoReceiverVariable: offset 

	bingo := true! !

!SyInstVarStoreLocator methodsFor: 'instruction decoding' stamp: 'SR 6/30/2010 11:10:51.153'!
storeIntoReceiverVariable: offset 

	bingo := true! !

ReferenceStream subclass: #SyReferenceMappingStream
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:19.245'!
mapping: aSyReferenceMapping

	^ self
		on: (RWBinaryOrTextStream on: '')
		mapping: aSyReferenceMapping.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:10.363'!
on: stream	mapping: aSyReferenceMapping
	
	^ (self on: stream)
		mapping: aSyReferenceMapping;
		yourself.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:28.091'!
streamedRepresentationOf: anObject mapping: aSyReferenceMapping
	
	"copied from DataStream class >> #streamedRepresentationOf:"
	| file |
	file := (RWBinaryOrTextStream on: (ByteArray new: 5000)).
	file binary.
	(self on: file mapping: aSyReferenceMapping) nextPut: anObject.
	^file contents! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:34.12'!
unStream: messageBytes mapping: aSyReferenceMapping

	"copied from DataStream class >> #streamedRepresentationOf:"
	^(self
		on: ((RWBinaryOrTextStream with: messageBytes) reset; binary)
		mapping: aSyReferenceMapping) next! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:28:48.149'!
mapping

	^ mapping ifNil: [mapping := SyReferenceMapping new]! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 14:59:33.612'!
mapping: aSyReferenceMapping

	mapping := aSyReferenceMapping! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:47.878'!
next

	| unconverted |
	unconverted := super next.
	^ self mapping backward value: unconverted.! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:57.417'!
nextPut: anObject

	| converted |
	converted := self mapping foreward value: anObject.
	^ super nextPut: converted.! !

!Object methodsFor: '*SqSync' stamp: 'SR 6/18/2010 14:46:18.381'!
isSqEntityType

	^ false! !

Object subclass: #SqEntity
	instanceVariableNames: 'dummy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

SqEntity subclass: #Person
	instanceVariableNames: 'givenName surname birthday address friends specialFriend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'rkrk 6/21/2010 00:03:36.08'!
= anObject

	^ self species = anObject species
		and: [self givenName = anObject givenName]
		and: [self surname = anObject surname]
		and: [self birthday = anObject birthday]
		and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'mt 7/21/2010 07:37:59.941'!
addFriend: aPerson
	"Bidirectional."
	
	(self friends includes: aPerson) ifTrue: [^ self].
	
	self friends add: aPerson.
	dummy := #friendAdded.
	aPerson addFriend: self.! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:01:42.055'!
address: addressOrString

	address := addressOrString! !

!Person methodsFor: 'accessing' stamp: 'mt 6/19/2010 17:07:32.415'!
bidirectionalSpecialFriend: aPerson

	(specialFriend == aPerson) ifTrue: [^ self].

	specialFriend := aPerson.
	aPerson bidirectionalSpecialFriend: self.! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 01:03:26.544'!
birthday: stringOrDate

	birthday := stringOrDate! !

!Person methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:03:56.682'!
changeNameOfSpecialFriend: newName

	"this is a method that does not change the state of self but
	of a referenced object"
	specialFriend ifNil: [self error: 'no special friend'].
	specialFriend givenName: newName.! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:58:53.508'!
friends

	^ friends! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 19:46:29.512'!
initialize

	friends := OrderedCollection new.! !

!Person methodsFor: 'as yet unclassified' stamp: 'rkrk 6/20/2010 15:42:14.424'!
printOn: stream

	stream
		nextPutAll: self givenName;
		space;
		nextPutAll: self surname.! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:22.951'!
specialFriend

	^ specialFriend! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:26.151'!
specialFriend: anObject

	specialFriend := anObject! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

SqEntity subclass: #PersonList
	instanceVariableNames: 'persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!PersonList methodsFor: 'accessing' stamp: 'mt 7/21/2010 07:37:32.626'!
addPerson: aPerson

	persons add: aPerson.
	dummy := #personAdded.
	^ aPerson! !

!PersonList methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 20:03:26.872'!
initialize

	super initialize.
	
	persons := OrderedCollection new.! !

!PersonList methodsFor: 'accessing' stamp: 'SR 6/14/2010 20:03:33.95'!
persons

	^ persons! !

!SqEntity methodsFor: 'testing' stamp: 'SR 6/18/2010 14:46:38.385'!
isSqEntityType

	^ true! !

SqEntity subclass: #SyAddress
	instanceVariableNames: 'street streetNo postalCode town'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyAddress class methodsFor: 'instance creation' stamp: 'rkrk 6/21/2010 00:00:15.949'!
street: street streetNo: streetNo postalCode: postalCode town: town

	^self new
		street: street;
		streetNo: streetNo;
		postalCode: postalCode;
		town: town.! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:32.688'!
postalCode
	^ postalCode ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.039'!
postalCode: anObject
	postalCode := anObject! !

!SyAddress methodsFor: 'printing' stamp: 'rkrk 6/21/2010 00:23:56.739'!
printOn: stream

	stream
		nextPutAll: self street;
		space;
		nextPutAll: self streetNo asString;
		cr;
		nextPutAll: self postalCode;
		space;
		nextPutAll: self town.! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:20.482'!
street
	^ street ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.014'!
street: anObject
	street := anObject! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:26.184'!
streetNo
	^ streetNo ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.026'!
streetNo: anObject
	streetNo := anObject! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:29.894'!
town
	^ town ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.051'!
town: anObject
	town := anObject! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'wrappers processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor class methodsFor: 'support' stamp: 'rkrk 6/14/2010 01:21:03.701'!
cleanClass: class

	"self cleanClass: Person"
	self new uninstrumentClass: class.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 17:59:40.643'!
instrumentClass: aClass

	{aClass. aClass class} do: [:c |
		c selectors do: [:selector |
			self instrumentMethod: selector inClass: c ]].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:01:36.24'!
instrumentMethod: selector inClass: aClass

	(self isMethodInstrumented: selector inClass: aClass) ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			(self wrappers add:
				(SyMethodWrapper on: selector inClass: aClass for: self))
				install]].! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'rkrk 7/21/2010 13:09:32.747'!
isMethodInstrumented: selector inClass: aClass

	^ self wrappers anySatisfy: [:wrapper |
		wrapper wrappedClass = aClass and: [wrapper selector = selector]].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'rkrk 7/20/2010 12:08:51.144'!
methodCalled: aSelector on: anObject with: anArrayOfObjects methodCallRecorder: methodCallRecorder
			
	self processor ifNil: [^self].
	self processor
		process: aSelector
		on: anObject
		with: anArrayOfObjects
		modifiedObjects: methodCallRecorder receiversThatExperiencedSideEffects! !

!SyClassInstrumentor methodsFor: 'printing' stamp: 'rkrk 7/21/2010 11:49:09.907'!
printOn: stream

	stream
		nextPutAll:  'a' , self class name;
		nextPutAll: ' for ';
		print: self processor.! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 7/19/2010 10:55:50.449'!
processor

	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 7/19/2010 10:55:53.165'!
processor: anObject

	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:04:16.121'!
uninstrumentAllAndReset

	self wrappers do: [:wrapper | wrapper uninstall].
	wrappers := nil.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:06:26.459'!
uninstrumentClass: aClass

	self wrappers
		select: [:wrapper | wrapper wrappedClass = aClass or: [wrapper wrappedClass = aClass class]]
		thenDo: [:wrapper | wrapper uninstall. self wrappers remove: wrapper ifAbsent: ["Weak."]]! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'mt 6/12/2010 17:49:25.948'!
wrappers

	^ wrappers ifNil: [wrappers := WeakSet new]! !

Object subclass: #SyClient
	instanceVariableNames: 'socket repository protocolProcessor connectionProcess incomingCommandProcess pendingApplyCommandQueue pendingApplyCommandQueueWorker shouldDeferSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SyClient commentStamp: 'mt 6/13/2010 15:24:45.171' prior: 0!
The client has 4 processes at the moment:

- UI process for interactions from workspace
- connection process to incoming network data
- process to handle incoming commands from protocol processor
- process to send apply-commands blocking!

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 01:44:57.148'!
commandsNotYetSend

	^ pendingApplyCommandQueue! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/5/2010 19:42:24.879'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository;
		startIncomingCommandProcess.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:30.287'!
deferSends

	shouldDeferSends := true.
	self killPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'connection-handling' stamp: 'mt 6/13/2010 15:35:02.365'!
disconnect

	"Kill command processing"
	incomingCommandProcess ifNotNilDo: [:proc | proc terminate].

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	self killPendingApplyCommandQueueWorker.
	socket close.
	
	"Clear method wrapper"
	repository clear.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:56.379'!
dontDeferSends

	shouldDeferSends := false.
	self pvtCheckPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 6/19/2010 14:59:01.165'!
initialize

	super initialize.
	
	repository := SyRepository new
		shouldCreateCommands: true;
		addDependent: self; "for sending commands"
		yourself.
	protocolProcessor := SySimpleProtocolProcessor new
		objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock).
	pendingApplyCommandQueue := SharedQueue new.
	shouldDeferSends := false.! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 6/13/2010 23:38:46.905'!
killPendingApplyCommandQueueWorker

	pendingApplyCommandQueueWorker isNilOrTerminated
		ifFalse: [pendingApplyCommandQueueWorker terminate].! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 17:15:54.023'!
log: msg

	Transcript cr; show: msg asString.! !

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 17:08:09.674'!
mapRegisteredObjectsBlock

	^ [:o | o].! !

!SyClient methodsFor: 'printing' stamp: 'rkrk 7/21/2010 11:51:09.401'!
printOn: stream

	stream
		nextPutAll: 'a' , self class name , '(';
		print: self identityHash;
		nextPut: $).! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 7/21/2010 15:25:26.905'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array command senderStream |
	"dont apply commands when there are still outgoing commands.
	outgoing worker will ensure restart of processIncomingCommands"
	self commandsNotYetSend size > 0 ifTrue: [
		self log: 'Stopping incomingCommandProcess because there are still outgoing commands in ' , self asString.
		self log: 'pendingApplyCommandQueueWorker isNilOrTerminated is ' , pendingApplyCommandQueueWorker isNilOrTerminated asString.
		self log: 'pendingApplyCommandQueue size is ' , pendingApplyCommandQueue size asString.
		self pvtCheckPendingApplyCommandQueueWorker.
		incomingCommandProcess terminate.
		^ self].
	array := protocolProcessor nextCommand.

	command := array second.
	senderStream := array third.
	
	self log: self asString , ' processing: ' , command asString.
	
	[command execute: self repository] "Just execute the command. No response expected yet."
		on: SyClientClosedConnectionException
		do: [senderStream close]
		on: SyApplyCommandRefusedException
		do: [self log: 'SyApplyCommand refused for ' , self asString. self reboot].! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 7/21/2010 15:15:00.503'!
pvtCheckPendingApplyCommandQueueWorker

	"Send all apply-commands blocking to verify their execution."
	pendingApplyCommandQueueWorker isNilOrTerminated ifFalse: [^self].
	pendingApplyCommandQueueWorker := [ | command result |
		[(command := pendingApplyCommandQueue nextOrNil) notNil] whileTrue: [
			self log: 'Client (' , self identityHash asString , ') sending: ' , command asString.
			result := protocolProcessor
				sendCommandBlocking: command
				on: socket.
			"Schedule a local command to be processed by the one and only process that accesses the repository."
			protocolProcessor nextCommandPutLocal:
				(SyResultProxyCommand forCommand: result)].
			self log: 'No commands for sending anymore in ', self asString.
			"ensure that incoming commands are processed when there are no outgoing anymore"
			self startIncomingCommandProcess] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'SR 6/14/2010 19:34:32.825'!
pvtUpdateRepository

	| command |
	command := protocolProcessor
		sendCommandBlocking: SyListCommand new
		on: socket.
	command executeWithResult: self repository.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 7/21/2010 20:54:43.424'!
reboot

	| newClient host port |
	host := socket remoteAddress.
	port := socket remotePort.
	
	self disconnect.
	
	newClient := self class new.
	newClient connectToHostNamed: (NetNameResolver stringFromAddress: host) port: port.
	
	self becomeForward: newClient.
	self rebooted.	! !

!SyClient methodsFor: 'signals' stamp: 'mt 7/21/2010 20:18:22.322'!
rebooted

	self emit.! !

!SyClient methodsFor: 'initialize-release' stamp: 'rkrk 6/13/2010 23:39:49.115'!
release

	self isConnected ifTrue: [self disconnect].
	^ super release! !

!SyClient methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:26:06.706'!
repository

	^ repository! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/7/2010 10:02:38.587'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [self disconnect].
			(protocolProcessor processDataFrom: socket)
				ifFalse: [self disconnect]]] sqFork.! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 7/21/2010 14:38:21.849'!
startIncomingCommandProcess
	"This process triggers the continous work of the server."
	
	incomingCommandProcess isNilOrTerminated ifFalse: [^self].
	Transcript cr; show: 'Starting incomingCommandProcess for ' , self asString.
	incomingCommandProcess := [
		[self processIncomingCommands] repeat.
	] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'rkrk 6/14/2010 00:28:20.513'!
update: anAspect with: command

	(anAspect = #operation) ifFalse: [super update: anAspect with: command].

	pendingApplyCommandQueue nextPut: command.
	shouldDeferSends ifFalse: [
		self pvtCheckPendingApplyCommandQueueWorker].! !

Object subclass: #SyCodeCoverageAnalyzer
	instanceVariableNames: 'packageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-ProjectAnalyzation'!

!SyCodeCoverageAnalyzer class methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:26:55.243'!
on: packageName

	^ self new
		packageName: packageName;
		yourself! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:34:01.838'!
allMethods

	^ self package methods! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:20:33.8'!
instrumentMethod: method

	| generatedCode callNode ast |
	generatedCode := self class name , ' addCall: (' , method methodClass name , '>>#' , method selector , ').'.
	callNode := RBParser parseExpression: generatedCode.
	ast := method parseTree.
	ast body addNodeFirst: callNode.
	method class compile: ast newSource! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:33:55.949'!
instrumentMethods

	self allMethods do: [:ea | self instrumentMethod: ea] displayingProgress: 'Compiling'.! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:37:20.508'!
measureCoverage

	"self instrumentMethods."
	| suite result |
	suite := TestSuite named: 'Coverage suite testing ' , packageName.
	(self testClasses first: 3) do: [:ea | ea addToSuiteFromSelectors: suite].
	result := TestResult new.
	suite tests do: [:test | test run: result] displayingProgress: 'Running'.! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:33:36.745'!
package

	^ (PackageInfo named: packageName)! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:27:14.87'!
packageName: string

	packageName := string! !

!SyCodeCoverageAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 8/25/2010 16:34:47.66'!
testClasses

	^ self package classes select: [:ea | ea inheritsFrom: TestCase]! !

Object subclass: #SyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

SyCommand subclass: #SyApplyCommand
	instanceVariableNames: 'selector receiverUUIDString wasExecuted arguments modifiedObjectUUIDsAndExpectedVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyApplyCommand class methodsFor: 'instance creation' stamp: 'rkrk 7/20/2010 17:51:18.147'!
receiver: aRegisteredObject selector: aSelector arguments: anArray modifiedObjects: collection

	"map UUID -> expected version so that not the entire registered object has to be send"
	| affectedRegObjectsDict |
	affectedRegObjectsDict := Dictionary newFrom: (
		collection asSet collect: [:regObj | regObj uuid -> regObj version]).
	^ self new
		receiverUUIDString: aRegisteredObject uuid asString;
		selector: aSelector;
		arguments: anArray;
		modifiedObjectUUIDsAndExpectedVersions: affectedRegObjectsDict;
		yourself.! !

!SyApplyCommand class methodsFor: 'execution' stamp: 'mt 6/15/2010 15:18:35.161'!
shouldBeReplicated

	^ true! !

!SyApplyCommand methodsFor: 'testing' stamp: 'rkrk 7/14/2010 23:59:02.431'!
= other

	^ self species = other species
		and: [self receiverUUID = other receiverUUID]
		and: [self selector = other selector]
		and: [self arguments = other arguments]! !

!SyApplyCommand methodsFor: 'testing' stamp: 'rkrk 7/20/2010 16:44:17.547'!
allModifiedObjectsAndReceiverExistIn: aSyRepository

	"^ (aSyRepository registeredObjectForUUID: self receiverUUID) notNil"
	^ ((self modifiedRegisteredObjectsOf: aSyRepository) includes: nil) not and: [
		(aSyRepository registeredObjectForUUID: self receiverUUID) notNil]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:22:01.583'!
arguments
	
	^ arguments! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:04.672'!
arguments: anObject

	arguments := anObject! !

!SyApplyCommand methodsFor: 'execution' stamp: 'rkrk 7/21/2010 13:53:54.864'!
execute: aSyRepository

	(self allModifiedObjectsAndReceiverExistIn: aSyRepository) ifFalse: [^false].
	(self hasConflict: aSyRepository) ifTrue: [^false].
	self reallyExecuteOn: aSyRepository.
	self informModifiedRegisteredObjectsOf: aSyRepository.
	self wasExecuted: true.
	^ true! !

!SyApplyCommand methodsFor: 'execution' stamp: 'rkrk 7/20/2010 12:15:37.354'!
executeWithResult: aRepository
	"If this command is sent blocking to the server, then this message should be called on the return value to see if the apply-command was accepted."

	self wasExecuted ifFalse: [
		SyApplyCommandRefusedException signal.
		^self].
	self informModifiedRegisteredObjectsOf: aRepository.! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 7/21/2010 13:44:53.09'!
expectedVersionOfReceiver

	^ self modifiedObjectUUIDsAndExpectedVersions
		at: self receiverUUID
		ifAbsent: [nil].! !

!SyApplyCommand methodsFor: 'testing' stamp: 'rkrk 7/21/2010 15:38:14.052'!
hasConflict: aSyRepository

	| expectedVersion |
	Transcript cr; show: 'Checking versions'.
	(self modifiedRegisteredObjectsOf: aSyRepository) do: [:regObj |
		expectedVersion := self modifiedObjectUUIDsAndExpectedVersions
			at: regObj uuid
			ifAbsent: [].
		regObj version = expectedVersion ifFalse: [
			Transcript cr;
				show: 'Conflict occurred: ';
				print: regObj; space;
				show: 'expected: '; print: expectedVersion;
				show: ' actual: '; print: regObj version.
			^ true]].
	^false.! !

!SyApplyCommand methodsFor: 'testing' stamp: 'rkrk 7/15/2010 00:01:35.941'!
hash

	^ (self receiverUUID hash bitXor: self selector hash) bitXor: self arguments hash.! !

!SyApplyCommand methodsFor: 'execution' stamp: 'rkrk 7/20/2010 12:15:27.627'!
informModifiedRegisteredObjectsOf: aSyRepository

	"Add to operation stack. Increase Version."
	| regObjects |
	regObjects := self modifiedRegisteredObjectsOf: aSyRepository.
	regObjects do: [:ea | ea addOperation: self].! !

!SyApplyCommand methodsFor: 'initialize-release' stamp: 'rkrk 7/20/2010 15:34:24.816'!
initialize

	super initialize.
	modifiedObjectUUIDsAndExpectedVersions := Dictionary new.! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 7/20/2010 12:11:59.624'!
modifiedObjectUUIDsAndExpectedVersions

	"UUID -> expectedVersion"
	^ modifiedObjectUUIDsAndExpectedVersions! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 7/20/2010 12:10:54.766'!
modifiedObjectUUIDsAndExpectedVersions: dictionary

	"UUID -> expectedVersion"
	modifiedObjectUUIDsAndExpectedVersions := dictionary! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 7/20/2010 12:13:38.907'!
modifiedRegisteredObjectsOf: repository

	| result |
	result := OrderedCollection new.
	self modifiedObjectUUIDsAndExpectedVersions keysAndValuesDo: [:uuid :expectedVersion |
		result add: (repository registeredObjectForUUID: uuid)].
	^ result.! !

!SyApplyCommand methodsFor: 'printing' stamp: 'rkrk 7/21/2010 13:45:26.759'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self receiverUUID;
		nextPut: $:;
		print: self expectedVersionOfReceiver;
		nextPutAll: '>>#';
		nextPutAll: self selector;
		nextPutAll: ' with ';
		print: arguments;
		nextPut: $).! !

!SyApplyCommand methodsFor: 'execution' stamp: 'rkrk 7/20/2010 14:36:25.267'!
reallyExecuteOn: aSyRepository

	| regRecv |
	regRecv := aSyRepository registeredObjectForUUID: self receiverUUID.
	WorldState addDeferredUIMessage: [
		aSyRepository dontCreateCommandsDuring: [
			regRecv client
				perform: self selector asSymbol
				withArguments: self arguments]].! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 21:51:19.365'!
receiverUUID

	^ UUID fromString: self receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:05.904'!
receiverUUIDString

	^ receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:09.051'!
receiverUUIDString: anObject

	receiverUUIDString := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:57.086'!
selector

	^ selector! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:53.995'!
selector: anObject

	selector := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 10:13:53.676'!
wasExecuted

	^ wasExecuted ifNil: [wasExecuted := false]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 19:09:57.172'!
wasExecuted: aBoolean

	wasExecuted := aBoolean.! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:01.606'!
needsObjectMapping
	"Returns whether this command should be serialised using the repository object mapping."
	^ true! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:20.567'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ false! !

!SyCommand methodsFor: 'comparing' stamp: 'rkrk 7/14/2010 23:57:49.463'!
= anObject

	self species = anObject species ifFalse: [^ false].
	"what is the test below good for? Squeak doesn't have multiple class versions"
	self class instSize = anObject class instSize ifFalse: [^ false]. 
	self instanceVariableValues withIndexDo: [:value :index | (anObject instVarAt: index) = value ifFalse: [^ false]].
	^ true
	! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:48:12.618'!
execute: aSyRepository
	"Should implement the functionality of this command. For now only the repository is supplied. Should return false if connection should be closed. Otherwise true."
	
	self subclassResponsibility! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:58.009'!
executeWithResult: aSyRepository
	"If the command has a special meaning when it is executed on the sender side after being executed on the receiver side, this should be overridden. Parameter and results are the same as with #execute:"! !

!SyCommand methodsFor: 'comparing' stamp: 'rkrk 7/15/2010 00:02:14.343'!
hash

	^ self instanceVariableValues hash! !

!SyCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 7/21/2010 14:11:29.455'!
isApplyCommand

	^ false! !

SyCommand subclass: #SyListCommand
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyListCommand commentStamp: 'SR 6/1/2010 14:12:13.781' prior: 0!
Example command: {"type": "command", "command": {"instVars": [null], "class": "SyListCommand"}, "id": 0}!

!SyListCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:39.026'!
needsObjectMapping

	^ false! !

!SyListCommand methodsFor: 'execution' stamp: 'mt 6/19/2010 14:55:12.942'!
execute: aSyRepository

	objects := aSyRepository metaRepository.
	^ true! !

!SyListCommand methodsFor: 'execution' stamp: 'mt 6/22/2010 18:12:20.491'!
executeWithResult: aSyRepository

	aSyRepository dontCreateCommandsDuring: [
		objects do: [:regObject |
			[aSyRepository
				register: regObject client
				uuid: regObject uuid
				version: regObject version
				asRoot: regObject isRoot]
			on: SyAlreadyRegisteredException
			do: ["Ignore possibly already registered objects."]]].
	^ true! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:45:57.765'!
objects

	^ objects! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:46:00.502'!
objects: anObject

	objects := anObject! !

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/14/2010 19:49:53.155'!
pvtCreateRegObjectDictionary: aRegisteredObject

	^ Dictionary newFrom: {
		#uuidString -> aRegisteredObject uuidString.
		#version -> aRegisteredObject version.
		#client -> aRegisteredObject client.}! !

SyCommand subclass: #SyQuitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyQuitCommand commentStamp: 'SR 6/1/2010 14:12:24.447' prior: 0!
Example command: {"type": "command", "command": {"instVars": [], "class": "SyQuitCommand"}, "id": 1}!

!SyQuitCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:16.985'!
execute: aSyRepository

	SyClientClosedConnectionException signal! !

SyCommand subclass: #SyRegisterCommand
	instanceVariableNames: 'client uuid versionOffset asRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisterCommand class methodsFor: 'instance creation' stamp: 'mt 6/19/2010 14:28:26.203'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean

	^ self new 
			client: anObject;
			uuid: aUUID;
			versionOffset: aVersionNumber;
			asRoot: aBoolean! !

!SyRegisterCommand class methodsFor: 'testing' stamp: 'mt 6/19/2010 14:44:38.693'!
needsObjectMapping

	^ false! !

!SyRegisterCommand class methodsFor: 'testing' stamp: 'SR 6/18/2010 15:33:24.715'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:52.735'!
asRoot

	^ asRoot! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:48.993'!
asRoot: anObject

	asRoot := anObject! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:05:03.911'!
client

	^ client! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:05:07.709'!
client: anObject

	client := anObject! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'mt 7/14/2010 09:30:57.999'!
execute: aSyRepository

	[aSyRepository dontCreateCommandsDuring: [
		aSyRepository
			register: self client
			uuid: self uuid
			version: self versionOffset
			asRoot: self asRoot
			ensureStrongReference: true]]
	on: SyAlreadyRegisteredException
	do: ["If it is already everything is ok already"].
	^ true
	.
	! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'SR 6/18/2010 15:46:30.554'!
executeWithResult: aSyRepository

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:22.941'!
uuid

	^ uuid! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:26.093'!
uuid: anObject

	uuid := anObject! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:30.04'!
versionOffset

	^ versionOffset! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:32.968'!
versionOffset: anObject

	versionOffset := anObject! !

SyCommand subclass: #SyResultProxyCommand
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyResultProxyCommand commentStamp: 'mt 6/13/2010 15:30:21.46' prior: 0!
Use this command to redirect #executeWithResult: to #execute: for any given command.!

!SyResultProxyCommand class methodsFor: 'instance creation' stamp: 'mt 6/13/2010 15:30:51.035'!
forCommand: aCommand

	^ self new
		command: aCommand! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:06'!
command

	^ command! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:13.062'!
command: aCommand

	command := aCommand.! !

!SyResultProxyCommand methodsFor: 'execution' stamp: 'mt 6/13/2010 15:31:36.929'!
execute: aRepository

	^ self command executeWithResult: aRepository! !

Object subclass: #SyMethodCall
	instanceVariableNames: 'receiver selector hasSideEffects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodCall class methodsFor: 'instance creation' stamp: 'rkrk 7/15/2010 00:52:12.328'!
receiver: anObject selector: selector hasSideEffects: bool

	^ self new
		receiver: anObject;
		selector: selector;
		hasSideEffects: bool;
		yourself.! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.514'!
hasSideEffects
	^ hasSideEffects! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.52'!
hasSideEffects: anObject
	hasSideEffects := anObject! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.485'!
receiver
	^ receiver! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.494'!
receiver: anObject
	receiver := anObject! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.501'!
selector
	^ selector! !

!SyMethodCall methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:51:19.508'!
selector: anObject
	selector := anObject! !

Object subclass: #SyMethodCallRecorder
	instanceVariableNames: 'recordedCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodCallRecorder methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:50:29.289'!
addCallWithReceiver: anObject selector: selector hasSideEffects: bool

	^ self recordedCalls add: (SyMethodCall
		receiver: anObject
		selector: selector
		hasSideEffects: bool)! !

!SyMethodCallRecorder methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 01:48:56.694'!
clearCalls

	self recordedCalls removeAll! !

!SyMethodCallRecorder methodsFor: 'testing' stamp: 'rkrk 7/15/2010 00:45:15.397'!
isEmpty

	^ self recordedCalls isEmpty! !

!SyMethodCallRecorder methodsFor: 'accessing' stamp: 'SR 7/19/2010 10:56:21.573'!
receiversThatExperiencedSideEffects

	^ self recordedCalls
		select: [:ea | ea hasSideEffects]
		thenCollect: [:ea | ea receiver].! !

!SyMethodCallRecorder methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 00:46:00.034'!
recordedCalls

	^ recordedCalls ifNil: [recordedCalls := OrderedCollection new]! !

!SyMethodCallRecorder methodsFor: 'testing' stamp: 'SR 7/19/2010 10:56:26.362'!
sideEffectOccurred

	^ self recordedCalls anySatisfy: [:ea | ea hasSideEffects].! !

Object subclass: #SyProjectAnalyzer
	instanceVariableNames: 'storyLineMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-ProjectAnalyzation'!

!SyProjectAnalyzer commentStamp: 'rkrk 8/17/2010 10:34:44.053' prior: 0!
analyzer := SyProjectAnalyzer new.
"annotate the result manually"
analyzer createTestList.

"-----------------------------"

"analyze the annotated list"
fn := '/Users/robertkrahn/studium/Master/AgileSoftwareEntwicklung/ausarbeitung/kindsOfTests.txt'.
analyzer := SyProjectAnalyzer dataFromFile: fn.

analyzer testsPerStoryCount.
analyzer testStoryMapping.

analyzer storyTestKindMapping.
analyzer storyTestKindMappingCSV.

analyzer testsGroupedByStory.!

!SyProjectAnalyzer class methodsFor: 'instance creation' stamp: 'rkrk 8/16/2010 15:30:46.559'!
dataFromFile: filename

	^ self new
		dataFromFile: filename;
		yourself.! !

!SyProjectAnalyzer methodsFor: 'data creation' stamp: 'rkrk 8/16/2010 14:26:22.118'!
createTestList

	"string of test classes with their methods"
	^ String streamContents: [:stream |
		self testClasses
			do: [:testClass |
				stream cr; cr; nextPutAll: '== ' , testClass name , ' =='.
				testClass allTestSelectors do: [:sel | stream cr; nextPutAll: sel; nextPutAll: ' ()']]].! !

!SyProjectAnalyzer methodsFor: 'initialize-release' stamp: 'rkrk 8/16/2010 15:32:44.71'!
dataFromFile: filename

	self storyLineMapping: (self storyLineMappingFromFile: filename).! !

!SyProjectAnalyzer methodsFor: 'helper' stamp: 'rkrk 8/16/2010 14:30:47.21'!
fileContent: filename

	^ FileStream
		fileNamed: filename
		do: [:stream | stream contents].! !

!SyProjectAnalyzer methodsFor: 'accessing' stamp: 'rkrk 8/16/2010 15:31:53.175'!
storyLineMapping

	^ storyLineMapping! !

!SyProjectAnalyzer methodsFor: 'accessing' stamp: 'rkrk 8/16/2010 15:32:13.607'!
storyLineMapping: dict

	storyLineMapping := dict! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 16:24:57.457'!
storyLineMappingFrom: stringToAnalyze

	| storyLineMapping |
	storyLineMapping := Dictionary new.
	stringToAnalyze linesDo: [: line |
		(self storyNames detect: [:story | line includesSubString: story] ifNone: []) ifNotNilDo: [:story |
			(storyLineMapping at: story ifAbsentPut: OrderedCollection new) add: line]].
	^ storyLineMapping! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 15:17:22.29'!
storyLineMappingFromFile: filename

	^ self storyLineMappingFrom: (self fileContent: filename).! !

!SyProjectAnalyzer methodsFor: 'accessing' stamp: 'rkrk 8/16/2010 14:50:23.828'!
storyNames

	"^  #('S1' 'S2' 'S3' 'S4' 'S5' 'S6' 'S7' 'S8' 'S9' 'S10' 'S11')"
	^ ((1 to: 11) collect: [:i | 'S' , i asString]) reverse.! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 15:35:34.424'!
storyTestKindMapping

	| storyTestKindMapping testKind |
	storyTestKindMapping := OrderedKeysIdentityDictionary new.
	self storyLineMapping keysAndValuesDo: [:story :lines |
		lines do: [:line |
			testKind := self testKinds detect: [:kind | line includesSubString: kind].
			(storyTestKindMapping at: story ifAbsentPut: Bag new) add: testKind]].
	storyTestKindMapping keysAndValuesDo: [:story :testKindBag |
		storyTestKindMapping at: story put: testKindBag valuesAndCounts].
	^ storyTestKindMapping.! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 15:48:51.477'!
storyTestKindMappingCSV

	| storyTestKindMapping numbers |
	storyTestKindMapping := self storyTestKindMapping.
	^ String streamContents: [:stream |
		stream nextPutAll: 'Story name,' , (self testKinds join: ','); cr.
		storyTestKindMapping keysAndValuesDo: [:story :kinds |
			numbers := self testKinds collect: [:kind | (kinds at: kind ifAbsent: [0]) asString].
			stream
				nextPutAll: story; nextPut: $,;
				nextPutAll: (numbers join: ',');
				cr]].
	! !

!SyProjectAnalyzer methodsFor: 'accessing' stamp: 'rkrk 8/16/2010 14:26:39.404'!
testClasses

	^ (SyTestCase withAllSubclasses union: {SyAddressBookTest. SyReferenceMappingStreamTest})
		select: [:testClass | testClass allTestSelectors notEmpty].! !

!SyProjectAnalyzer methodsFor: 'accessing' stamp: 'rkrk 8/16/2010 15:25:43.176'!
testKinds

	^ #('acceptance test' 'bug test' 'unit test')! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 15:34:01.442'!
testStoryMapping

	"TestClass>>testSelector -> story"
	| testStoryMapping |
	testStoryMapping := Dictionary new.
	self storyLineMapping keysAndValuesDo: [:story :lines |
		lines do: [:line | |testName|
			testName := line copyUpTo: Character space. "test name comes first"
			testStoryMapping at: testName put: story]].
	^ testStoryMapping.! !

!SyProjectAnalyzer methodsFor: 'data creation' stamp: 'rkrk 8/16/2010 16:22:25.79'!
testsGroupedByStory

	| story lines |
	^ (self storyLineMapping associations collect: [:assoc |
		story := assoc key. lines := assoc value.
		story , String cr , (lines join: String cr)]) join: String cr , String cr.! !

!SyProjectAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 8/16/2010 15:34:17.806'!
testsPerStoryCount

	| result |
	result := OrderedKeysIdentityDictionary new.
	self storyLineMapping keysAndValuesDo: [:story :lines | result at: story put: lines size].
	^ result.! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/12/2010 19:50:29.738'!
processDataFrom: aStream

	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:46:29.438'!
sendCommandNonBlocking: anOperation on: aStream
	"Sends a command to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/5/2010 19:50:05.89'!
sendCommandNonBlocking: aSyCommand onAll: someStreams
	"Sends a command to some servers/clients, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:47:04.728'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends a command back after it has been processed, does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'outgoingQueue outgoingQueueWorker incomingQueue currentCommandResultCache currentCommandResultSemaphore currentCommandResultId nextCommandID objectMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor commentStamp: 'mt 5/31/2010 09:15:17.382' prior: 0!
Wire Protocol
---

1) All data is serialized or deserialized according to #serialize: and #deserialize:.

2) In a first version, JSON is used to serialize messages.

3) Messages are separated on the wire using a unique #messageEndToken.

4) Each message is dictionary with the following content:
	#channel -> aNumber
	#data -> aString
	
5) There is a #channel for commands, one for results of commands, and one for operations/updates.

6) For each command an increasing ID is sent along to verify the result on the command result channel:
	#id -> aNumber
	#command -> aString
	
7) The result of a command is as follows:
	#id -> aNumber
	#result -> aString
	
8) Update messages have to be deserialized in the #data field.!

!SySimpleProtocolProcessor class methodsFor: 'constants' stamp: 'SR 6/1/2010 12:24:19.963'!
messageEndToken
	"Return the token that will be transferred after the end of each message to allow the recipient of the message to recognize it fully. No message should contain this token."
	
	^ String crlf! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:09:48.087'!
deserialize: aByteString withMapping: aBoolean

	^ SyReferenceMappingStream
		unStream: (ByteArray readFrom: aByteString)
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'mt 6/15/2010 15:37:39.45'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new. "To send outgoing commands."
	incomingQueue := SharedQueue new. "To schedule incoming commands."
	
	currentCommandResultSemaphore := Semaphore new. "To wait for command results."
	nextCommandID := 0.
	
	objectMapping := SyReferenceMapping identity.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'rkrk 6/13/2010 23:40:11.99'!
killOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated
		ifFalse: [outgoingQueueWorker terminate].! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/1/2010 13:59:39.663'!
nextCommand
	"Retrieve the next pending command from the incoming command queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:28:26.257'!
nextCommandPutLocal: aCommand
	"Schedule a command that was obiously created locally and has to be processed locally too. Intent: Reusage of incomingQueue for process synchronization."
	
	incomingQueue nextPut: {
		-1. "Local command."
		aCommand.
		nil}.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:45:15.615'!
nextUpdate
	"Retrieve the next pending operation from the incoming update queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:09.217'!
objectMapping

	^ objectMapping! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:12.091'!
objectMapping: anObject

	objectMapping := anObject! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/15/2010 15:20:57.869'!
processDataFrom: aStream
	"Depending on the channel, process the data"
	
	| message command rawMessage commandClass |
	rawMessage := aStream upToAll: SySimpleProtocolProcessor messageEndToken.
	rawMessage isEmpty ifTrue: [^ false].
	
	message := self deserialize: rawMessage withMapping: false.
	commandClass := Smalltalk classNamed: (message at: #commandClass).
	command := self deserialize: (message at: #command) withMapping: commandClass needsObjectMapping.

	((message at: #type) = 'command') ifTrue: [
		^ self
			pvtProcessCommand: command
			with: (message at: #id)
			from: aStream].
			
	((message at: #type) = 'result') ifTrue: [
		^ self
			pvtProcessCommandResult: command
			with: (message at: #id)
			from: aStream].
			
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:43.392'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated ifTrue: [
		outgoingQueueWorker := [ | opArray operationDict |
			opArray := outgoingQueue nextOrNil.
			[opArray isNil] whileFalse: [
				self
					pvtSendCommand: opArray second
					with: opArray first
					on: opArray third.
				opArray := outgoingQueue nextOrNil]] sqFork].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'rkrk 6/15/2010 00:40:01.712'!
pvtCreateCommand: aDictionary

	| typeName variableData newObject |
	typeName := aDictionary at: #class.
	variableData := aDictionary at: #instVars.
	
	newObject := (Smalltalk classNamed: typeName asSymbol) new.
	variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
	^ newObject! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:54:22.057'!
pvtNextCommandId

	| result |
	result := nextCommandID.
	nextCommandID := nextCommandID + 1.
	^ result! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:25.804'!
pvtProcessCommand: aCommand with: aCommandId from: aStream
	"Support commands."
	
	"Schedule incoming command to be processed by client or server application."
	incomingQueue nextPut: {
		aCommandId.
		aCommand.
		aStream}.
		
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:33.336'!
pvtProcessCommandResult: aCommand with: aCommandId from: aStream
	"Save the command result and signal."
	
	currentCommandResultId := aCommandId.
	currentCommandResultCache := aCommand.
	currentCommandResultSemaphore signal.

	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:26:43.641'!
pvtSendCommand: aCommand with: aCommandId on: aStream

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'command'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: false.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:58.437'!
sendCommandBlocking: command on: stream
	"Sends a command and returns its answer. Responsible for command-response-scheme."

	| commandId |
	commandId := self
		sendCommandNonBlocking: command
		on: stream.
	[currentCommandResultId = commandId] whileFalse: [ 
		currentCommandResultSemaphore wait].
	^ currentCommandResultCache.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:19.306'!
sendCommandNonBlocking: aSyCommand on: aStream

	| commandId |
	commandId := self pvtNextCommandId.
	outgoingQueue nextPut: {commandId. aSyCommand. aStream.}.
	self pvtCheckOutgoingQueueWorker.
	
	^ commandId! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:44.447'!
sendCommandNonBlocking: aSyCommand onAll: someStreams

	^ someStreams collect: [:aStream | 
		self
			sendCommandNonBlocking: aSyCommand
			on: aStream].! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:39:04.504'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends command result repeating the given ID so that the sender of the command can map the result correctly."

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'result'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: true.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:07:46.568'!
serialize: anObject withMapping: aBoolean

	^ (SyReferenceMappingStream
		streamedRepresentationOf: anObject
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])) storeString! !

Object subclass: #SyReference
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyReference class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 16:11:30.775'!
fromRegisteredObject: aSyRegisteredObject

	^ self new uuid: aSyRegisteredObject uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:10:51.52'!
uuid

	^ uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:11:00.598'!
uuid: aUUID

	uuid := aUUID! !

Object subclass: #SyReferenceMapping
	instanceVariableNames: 'foreward backward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMapping commentStamp: 'mt 6/15/2010 14:58:21.783' prior: 0!
The mappings are blocks exepecting one argument (the object to be mapped)!

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:11.102'!
backward: aBackwardMappingBlock

	^ self new backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:01.166'!
foreward: aForwardMappingBlock

	^ self new foreward: aForwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:32:40.963'!
foreward: aForwardMappingBlock backward: aBackwardMappingBlock

	^ self new
		foreward: aForwardMappingBlock;
		backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:35:38.664'!
identity

	^ self new! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:39.715'!
backward

	^ backward ifNil: [ backward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:24.813'!
backward: anObject

	backward := anObject! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:50.078'!
foreward

	^ foreward ifNil: [ foreward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:14.592'!
foreward: anObject

	foreward := anObject! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations versionOffset isRoot strongClientReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRegisteredObject commentStamp: 'mt 7/13/2010 15:09:03.081' prior: 0!
I a encapsulate meta-information of a domain object. This includes, e.g., a uuid for distributed-system-wide domain object identity.!

!SyRegisteredObject class methodsFor: 'instance creation' stamp: 'mt 7/13/2010 17:10:33.068'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean

	^ self new
		isRoot: aBoolean;
		client: anObject;
		uuid: aUUID;
		versionOffset: aVersionNumber;
		yourself.! !

!SyRegisteredObject class methodsFor: 'instance creation' stamp: 'mt 7/13/2010 17:12:11.964'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean ensureStrongReference: strong

	^ self new
		isRoot: aBoolean;
		strongClientReference: strong;
		client: anObject;
		uuid: aUUID;
		versionOffset: aVersionNumber;
		yourself.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'rkrk 7/14/2010 23:53:32.717'!
addOperation: command

	^ operations add: command! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 7/13/2010 17:09:07.522'!
client

	^ (self isRoot or: [self strongClientReference])
		ifFalse: [
			client ifNil: [client := WeakArray new: 1].
			client first]
		ifTrue: [client]! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 7/13/2010 17:09:11.932'!
client: anObject

	(self isRoot or: [self strongClientReference])
		ifFalse: [
			client ifNil: [client := WeakArray new: 1].
			client at: 1 put: anObject]
		ifTrue: [client := anObject].! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'mt 7/13/2010 17:11:36.952'!
initialize

	super initialize.
	
	isRoot := false.
	strongClientReference := false.
	
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:40:17.638'!
isRoot

	^ isRoot! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 7/13/2010 17:08:25.72'!
isRoot: aBoolean

	aBoolean = isRoot ifTrue: [^ self]. "No change."
	
	isRoot := aBoolean.
	self updateClientReference.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:45.967'!
operations

	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:49.859'!
operations: anObject

	operations := anObject! !

!SyRegisteredObject methodsFor: 'as yet unclassified' stamp: 'rkrk 7/15/2010 01:28:32.528'!
printOn: stream

	super printOn: stream.
	self client ifNil: [^self].
	stream
		nextPut: $(;
		print: self client;
		nextPut: $).! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 7/13/2010 17:09:53.704'!
strongClientReference
	
	^ strongClientReference! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 7/13/2010 17:08:44.122'!
strongClientReference: aBoolean
	
	strongClientReference = aBoolean ifTrue: [^ self]. "No change."
	
	strongClientReference := aBoolean.
	self updateClientReference.! !

!SyRegisteredObject methodsFor: 'updating' stamp: 'mt 7/13/2010 17:20:25.822'!
updateClientReference

	|tmp|	
	tmp := (self isRoot or: [self strongClientReference])
		ifFalse: ["Switch to weak reference." client at: 1]
		ifTrue: ["Switch to strong reference." client].

	client := nil.
	self client: tmp.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:43.328'!
uuid

	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:46.39'!
uuid: anObject

	uuid := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 11:54:26.291'!
uuidString

	^ self uuid asString! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:25.975'!
version
	"Return an integer that represents the version of this object with:
	o1 isNewer o2 --> o1 version > o2 version"
	
	^ self operations size + self versionOffset! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:39.679'!
versionOffset
	"If only the latest operations are available in the stack, this offset can be used to calculate the real version."
	
	^ versionOffset ifNil: [versionOffset := 0]! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:16.786'!
versionOffset: anInteger
	
	versionOffset := anInteger.! !

Object subclass: #SyRepository
	instanceVariableNames: 'objects instrumentor shouldCreateCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRepository commentStamp: 'mt 7/13/2010 15:08:11.765' prior: 0!
I store a list of all meta-objects corresponding to the domain object graph.!

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:13:47.421'!
all

	^ self metaRepository collect: [:regObject | regObject client]! !

!SyRepository methodsFor: 'reference mapping' stamp: 'mt 7/13/2010 15:14:59.287'!
backwardReferenceMappingBlock
	"Maps a reference/meta-object to its real domain object."
	
	^  [:obj | 
		obj class == SyReference
			ifTrue: [(self registeredObjectForReference: obj) ifNotNilDo: [:obj2| obj2 client]]
			ifFalse: [obj]]! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:33:24.948'!
clear

	objects := nil.
	instrumentor uninstrumentAllAndReset.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/19/2010 14:59:44.892'!
dontCreateCommandsDuring: block

	| tmp |
	tmp := self shouldCreateCommands.
	self shouldCreateCommands: false.
	block value.
	self shouldCreateCommands: tmp.! !

!SyRepository methodsFor: 'weakness' stamp: 'mt 7/13/2010 16:11:50.78'!
finalizeValues
	"To be used by the WeakArray finalization process."
	
	self metaRepository removeAllSuchThat: [:regObj | regObj client isNil].! !

!SyRepository methodsFor: 'reference mapping' stamp: 'mt 7/13/2010 15:15:40.969'!
forewardReferenceMappingBlock
	"Maps a real domain object to its registered/meta-object."
	
	^ [:obj | |regObject|
		regObject := self registeredObjectForDomainObject: obj.
		regObject
			ifNil: [obj]
			ifNotNil: [SyReference fromRegisteredObject: regObject]].! !

!SyRepository methodsFor: 'initialize-release' stamp: 'mt 7/13/2010 16:14:50.327'!
initialize

	super initialize.

	instrumentor := SyClassInstrumentor new processor: self.
	shouldCreateCommands := false.
	
	"Control the weak part of me."
	WeakArray addWeakDependent: self.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:13:29.75'!
isEmpty

	^ self metaRepository isEmpty! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 16:11:00.761'!
metaRepository

	^ objects ifNil: [objects := OrderedCollection new]! !

!SyRepository methodsFor: 'printing' stamp: 'rkrk 7/21/2010 12:05:48.951'!
printOn: stream

	stream
		nextPutAll:  'a' , self class name;
		nextPutAll: ' for ';
		print: self syClients.! !

!SyRepository methodsFor: 'method wrappers' stamp: 'rkrk 7/20/2010 12:08:47.604'!
process: selector on: obj with: args modifiedObjects: objectsWithSideEffects

	| registeredReceiverObject applyCommand registeredAffectedObjects |
	"Only methods with side effects are interesting"
	objectsWithSideEffects ifEmpty: [^ self].
	
	"Recursion exit condition. Allows multiple clients/servers per Image in combination with multiple SyMethodWrappers."
	registeredReceiverObject := (self registeredObjectForDomainObject: obj) ifNil: [^ self].
	registeredAffectedObjects := objectsWithSideEffects
		collect: [:ea | self registeredObjectForDomainObject: ea]
		thenSelect: [:ea | ea notNil].	.
	
	self pvtCheckArguments: args.
	
	applyCommand := SyApplyCommand
		receiver: registeredReceiverObject
		selector: selector
		arguments: args
		modifiedObjects: registeredAffectedObjects.
		
	self changed: #operation with: applyCommand.! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/18/2010 15:55:16.467'!
pvtCheckArguments: args.
	
	args do: [:obj |
		obj isSqEntityType ifTrue: [
			(self registeredObjectForDomainObject: obj) ifNil: [
				self register: obj]]].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:18:43.373'!
register: anObject

	^ self register: anObject uuid: UUID new! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:22:32.958'!
register: anObject uuid: aUUID

	^ self
		register: anObject
		uuid: aUUID
		version: 0 "New object."! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:38:17.287'!
register: anObject uuid: aUUID version: aVersionNumber

	^ self register: anObject uuid: aUUID version: aVersionNumber asRoot: false! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 17:18:25.773'!
register: anObject uuid: aUUID version: aVersionNumber asRoot: aBoolean

	^ self
		register: anObject 
		uuid: aUUID
		version: aVersionNumber 
		asRoot: aBoolean 
		ensureStrongReference: false. "Default client behavior."! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 17:15:46.501'!
register: anObject uuid: aUUID version: aVersionNumber asRoot: aBoolean ensureStrongReference: strong

	| registeredObject |
	(self all identityIncludes: anObject) ifTrue: [
		SyAlreadyRegisteredException signal: 'Object already registered'].
	(self metaRepository anySatisfy: [:regObject |
		regObject uuid = aUUID]) ifTrue: [
			SyAlreadyRegisteredException signal: 'UUID already registered'].
	
	registeredObject := SyRegisteredObject
		client: anObject
		uuid: aUUID
		versionOffset: aVersionNumber
		asRoot: aBoolean
		ensureStrongReference: strong.
	self metaRepository add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	self shouldCreateCommands ifTrue: [ 
		instrumentor instrumentClass: anObject class].
	
	"Replicate"
	self shouldCreateCommands ifTrue: [ | registerCommand |
		registerCommand := SyRegisterCommand
			client: anObject
			uuid: aUUID
			versionOffset: aVersionNumber
			asRoot: aBoolean.
		
		self changed: #operation with: registerCommand].
	
	^ registeredObject.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:12:11.257'!
registeredObjectForDomainObject: aDomainObject

	^ self metaRepository
		detect: [:regObj | regObj client == aDomainObject]
		ifNone: []! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:41.036'!
registeredObjectForReference: aSyReference

	^ self registeredObjectForUUID: aSyReference uuid! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:12:00.601'!
registeredObjectForUUID: aUUID

	^ self metaRepository
		detect: [:regObj | regObj uuid = aUUID]
		ifNone: [].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:40.879'!
resolve: aUUID

	^ (self registeredObjectForUUID: aUUID) ifNotNilDo: [ :ro| ro client]
! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:11:19.354'!
rootObject

	^ (self metaRepository
		detect: [:o | o isRoot ]
		ifNone: [^ nil]) client! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:40:54.209'!
rootObject: anObject
	
	self flag: #SemanticFail. "#rootObject returns a real domain object. This one returns the registered object."
	^ self register: anObject uuid: UUID new version: 0 asRoot: true! !

!SyRepository methodsFor: 'accessing' stamp: 'mt 6/19/2010 15:54:18.36'!
shouldCreateCommands

	^ shouldCreateCommands! !

!SyRepository methodsFor: 'accessing' stamp: 'mt 6/19/2010 15:54:18.321'!
shouldCreateCommands: aBoolean

	shouldCreateCommands := aBoolean.
	self updateMethodWrappers: aBoolean.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:13:19.21'!
size

	^ self metaRepository size! !

!SyRepository methodsFor: 'printing' stamp: 'rkrk 7/21/2010 12:06:05.731'!
syClients

	^ self dependents select: [:ea | ea isKindOf: SyClient].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 15:12:50.819'!
unregister: anObject

	self metaRepository removeAllSuchThat: [:regObject |
		regObject client == anObject].
	
	self shouldCreateCommands ifTrue: [
		(self metaRepository contains: [:o | o client class == anObject class]) ifFalse: [
			instrumentor uninstrumentClass: (anObject class)]].! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/1/2010 09:45:23.992'!
updateMethodWrappers: aBoolean

	aBoolean ifTrue: [
		"enable Method Wrappers for all classes".
		self all do: [ :o | instrumentor instrumentClass: (o class) ].
		
	] ifFalse: [
		"disable Method Wrappers for all classes."
		instrumentor uninstrumentAllAndReset.
	]! !

SyRepository subclass: #SyStrongRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyStrongRepository commentStamp: 'mt 7/13/2010 17:13:55.194' prior: 0!
Ensure strong references in registered objects.!

!SyStrongRepository methodsFor: 'repository' stamp: 'mt 7/13/2010 17:18:39.643'!
register: anObject uuid: aUUID version: aVersionNumber asRoot: aBoolean

	^ self
		register: anObject 
		uuid: aUUID
		version: aVersionNumber 
		asRoot: aBoolean 
		ensureStrongReference: true. "Server keeps all references."! !

Object subclass: #SyServer
	instanceVariableNames: 'tcpServer repository mainProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SyServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SyServer methodsFor: 'signals' stamp: 'mt 6/23/2010 15:59:46.309'!
commandExecuted: aCommandClass

	self emit.! !

!SyServer methodsFor: 'signals' stamp: 'mt 6/13/2010 16:18:21.032'!
connectionsChanged

	self emitAlways.! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 7/13/2010 17:17:44.979'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	self connect: tcpServer signal: #connectionsChanged toSelector: #connectionsChanged.

	repository := SyStrongRepository new.
		
	tcpServer protocolProcessor: (SySimpleProtocolProcessor new
			objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock)).! !

!SyServer methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 14:47:16.469'!
log: msg

	Transcript cr; show: msg asString.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 6/23/2010 16:00:05.605'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array commandId command senderStream |
	array := tcpServer protocolProcessor nextCommand.

	commandId := array first.
	command := array second.
	senderStream := array third.
	
	self log: 'SyServer processing: ' , command asString.
	
	[
		| succeeded |
		succeeded := command execute: self repository.
		self commandExecuted: command class.
		
		tcpServer protocolProcessor
			sendCommandResult: command
			with: commandId
			on: senderStream.
		succeeded & command class shouldBeReplicated ifTrue: [
			"Replicate the command if neccessary"
			self log: 'Server broadcasting: ' , command asString.
			tcpServer protocolProcessor
				sendCommandNonBlocking: command
				onAll: (tcpServer connections copyWithout: senderStream)]
	]
	on: SyClientClosedConnectionException
	do: [senderStream close].
	
! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 6/22/2010 16:56:55.999'!
release

	self stop.	
	super release.! !

!SyServer methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:57.017'!
repository

	^ repository! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 6/22/2010 16:55:46.97'!
start

	self startMainProcess.
	tcpServer listenOn: self class defaultPort.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:20:45.756'!
startMainProcess
	"This process triggers the continous work of the server."
	
	mainProcess := [
		[self processIncomingCommands] repeat.
	] fork.! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 7/11/2010 11:29:00.259'!
stop

	tcpServer close.
	mainProcess ifNotNilDo: [:proc | proc terminate. mainProcess := nil].! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'handling' stamp: 'mt 7/11/2010 11:50:11.9'!
close

	"Closing listen part"
	listenProcess ifNotNilDo: [:p | p terminate. listenProcess := nil].
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.
	
	! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'signals' stamp: 'SR 6/3/2010 11:59:48.882'!
connectionsChanged

	self emit! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/29/2010 12:32:13.073'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:47:27.907'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
	
	self connectionsChanged.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:48:12.249'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [Processor activeProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket) ifFalse: [Processor activeProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug.
			self connectionsChanged].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/31/2010 08:01:17.378'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket isValid ifTrue: [listenSocket closeAndDestroy].
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

Exception subclass: #SyAlreadyRegisteredException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

Exception subclass: #SyApplyCommandRefusedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

Exception subclass: #SyClientClosedConnectionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClientClosedConnectionException commentStamp: 'SR 6/5/2010 19:16:20.123' prior: 0!
Thrown by execute methods if client connection should be closed.!

MwMethodWrapper subclass: #SyGUIProcessTestMethodWrapper
	instanceVariableNames: 'isGuiProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyGUIProcessTestMethodWrapper methodsFor: 'as yet unclassified' stamp: 'SR 6/29/2010 11:15:51.161'!
initialize

	super initialize.
	isGuiProcess := true.! !

!SyGUIProcessTestMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/29/2010 11:09:23.392'!
isGuiProcess
	^ isGuiProcess! !

!SyGUIProcessTestMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/29/2010 11:09:23.398'!
isGuiProcess: anObject
	isGuiProcess := anObject! !

!SyGUIProcessTestMethodWrapper methodsFor: 'evaluating' stamp: 'SR 6/29/2010 15:35:29.752'!
valueWithReceiver: anObject arguments: args

	(anObject class == Person) ifTrue: [
		Transcript cr; show: 'asdasd'; cr.
		isGuiProcess :=  isGuiProcess and: [Processor activeProcess == Project uiProcess]].
	^ super valueWithReceiver: anObject arguments: args! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor storesIntoInstVar methodCallRecordersForProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodWrapper class methodsFor: 'constants' stamp: 'mt 7/13/2010 14:57:37.086'!
notReplicatedSelectors
	"Return a list of selectors that are not replicated using apply-commands."
	
	^ #(= printOn: asString)! !

!SyMethodWrapper class methodsFor: 'instance creation' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'debugging' stamp: 'rkrk 7/21/2010 12:06:17.985'!
allSyClients

	^ self allSyWrappers gather: [:wrapper | wrapper instrumentor processor dependents]! !

!SyMethodWrapper methodsFor: 'debugging' stamp: 'rkrk 7/21/2010 12:01:06.723'!
allSyWrappers

	| installedWrappers method |
	installedWrappers := OrderedCollection new.
	method := self.
	[installedWrappers add: method.
	method := method clientMethod] doWhileTrue: [method isMwMethodWrapper].
	^ installedWrappers! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'rkrk 7/15/2010 01:08:28.548'!
hasInstVarStore

	^ self clientMethod hasInstVarStore! !

!SyMethodWrapper methodsFor: 'as yet unclassified' stamp: 'rkrk 7/15/2010 00:41:01.132'!
install

	super install.
	self clientMethod ifNil: [^self].
	storesIntoInstVar := self clientMethod hasInstVarStore.! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'rkrk 6/2/2010 20:47:28.979'!
isSelectorBanned

	^ SyMethodWrapper notReplicatedSelectors includes: self selector! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'rkrk 7/21/2010 13:07:08.706'!
methodCallRecorder

	"a per process value"
	methodCallRecordersForProcesses ifNil: [methodCallRecordersForProcesses := IdentityDictionary new].
	^ methodCallRecordersForProcesses
		at: Processor activeProcess identityHash
		ifAbsentPut: [SyMethodCallRecorder new].! !

!SyMethodWrapper methodsFor: 'as yet unclassified' stamp: 'rkrk 7/21/2010 11:50:06.225'!
printOn: stream

	super printOn: stream.
	stream
		nextPutAll: ' for ';
		print: self instrumentor.! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/30/2010 11:52:09.928'!
storesIntoInstVar

	^ storesIntoInstVar! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 7/19/2010 10:54:24.378'!
valueWithReceiver: anObject arguments: args

	| result recorder firstCall |
	recorder := self methodCallRecorder.

	"If isEmpty no calls recorded yet, this is the first one"
	firstCall := recorder isEmpty.

	[recorder
		addCallWithReceiver: anObject
		selector: self selector
		hasSideEffects: self storesIntoInstVar.
		
	result := self clientMethod
		valueWithReceiver: anObject
		arguments: args.
		
	(firstCall and: [self isSelectorBanned not]) ifTrue: [
		self instrumentor
			methodCalled: self selector
			on: anObject
			with: args
			methodCallRecorder: recorder].
	^ result
	] ensure: [firstCall ifTrue: [recorder clearCalls]].! !
